<?php include "TNavDef.php" ?>

<style>
.TNav
{ 
  text-align: left;
  padding: 2px 5px;
  white-space:  nowrap; 
  border: 1px solid #0048F1;
  border-bottom: none;
  border-radius: 4px 4px 0 0;	
  user-select: none;
  z-index: 10;				
  background-color: var(--tables-background); 
}	 

caption.TNav
{ position: sticky;
  top: 0;
}
.TNav > * { vertical-align: middle; }
.TNav > .NavBtn { padding: 3px;}

*.ts_edit   .NavTitle,
*.ts_insert .NavTitle { display: none; }


*.ts_edit   .NavLabel::after {content: ""; color: red;}
*.ts_insert .NavLabel::after {content: "";     color: red;}

*.ts_disabled .NavBtn:not(.ts_disabled),
*.ts_browse   .NavBtn:not(.ts_browse),
*.ts_selected .NavBtn:not(.ts_selected),
*.ts_edit     .NavBtn:not(.ts_edit),
*.ts_insert   .NavBtn:not(.ts_insert),
*.readonly    .NavDelete,
*.row-readonly .NavDelete,
*.row-nodelete .NavDelete,
*.readonly    .NavInsert
{ 
  pointer-events: none; 
  filter: grayscale(1);
  opacity: 0.5;
}
</style>

<style media=print>
caption.TNav {display: none;}
</style>


<script>
//default navigator buttons actions for table
function nav_get_table(btn)
{ if(t=btn.closest('table.table')) return t;
  if(f=btn.closest('form')) return f.table_instance;
}

function nav_def_insert(btn)
{ table_insert(nav_get_table(btn)); }

function nav_def_post(btn)
{ table_post(nav_get_table(btn)); }

function nav_def_delete(btn)
{ if(confirm("    ?"))  
   table_delete(nav_get_table(btn));
}

function nav_def_cancel(btn)
{ table_cancel(nav_get_table(btn)); }

//default navigator buttons actions for dbform
function nav_dbform_post(btn)
{ table_dbform_post(btn.closest('form')); }

function nav_dbform_cancel(btn)
{ table_dbform_cancel(btn.closest('form')); }
</script>


