<?php 
include "login.php"; 
include "options.php"; 
include "password.php"; 


$opt_empty = new d_option("operators/restrict_empty_password");
$err=null;

try {
if($_SERVER['REQUEST_METHOD']==='POST')
{
 if($opt_empty->get(0) && empty($_POST['newpass'])) throw new Exception('  ');
 if($_POST['newpass']!=$_POST['testpass']) throw new Exception(' ');
 
 if(HashPassword2($_POST['currpass'])!=$db->query("select hash2 from D_EDITOR_SETTINGS where editor=$editor")->fetchColumn()) 
    throw new Exception('   ');

 $q=$db->prepare("update D_EDITOR_SETTINGS set hash_password=?, hash2=? where editor=$editor");
 $q->execute([HashPassword($_POST['newpass']), HashPassword2($_POST['newpass'])]);

 (new d_editor_option("operators/password_created"))->set(date('d.m.Y'));
 $db->exec("insert into EVENTS (event_type,param1) values (106,$editor)");
 
 header("Location: startup.php");
 exit(); 
}

} catch (Exception $e) { $err = $e->getMessage(); }  


include "form.php"; 
include "lang_ind.php"; 
?>
<link rel="icon" href="img/32.png">
<link rel="stylesheet" href="TButton.css"> 




<style>
tr { height: 3em; }
table {margin: 1ch;}

#lang {float: right;}	   

.err {font-size: large;
      color: red;
	  text-align: center; 
	 }

</style>


<title> </title>

</head>
<body id=workarea>

<form class="window screen_center" method=POST
      oninput="check_pass(this)"
	  onkeydown="formkeydown(this, event)">
	  
<div class=title><img src="img/32.png">    <span id=lang><span></div>

<? if($err) echo "<div class=err>$err</div>"; ?>

<table>
<tr>
<td> </td>
<td><input type=password name=currpass autofocus class=autotab></td>
</tr>
<tr>
<td> </td>
<td><input type=password name=newpass <? if($opt_empty->get(0)) echo 'required' ?> class=autotab></td>
</tr>
<tr>
<td>  </td>
<td><input type=password name=testpass class=autotab></td>
</tr>

<tr>
<td colspan=2 style="text-align: center">
<button type=submit  class="TButton autotab" style="margin-right: 2ch"><img src="img/ok.png"><span></span></button>
<button type=reset   class=TButton><img src="img/cancel.png"><span>C</span></button>
</td>
</tr>
</table>

<script>
function check_pass(form)
{
 form.newpass.setCustomValidity(form.currpass.value==form.newpass.value ? '      ' : ''); 
 form.testpass.setCustomValidity(form.newpass.value!=form.testpass.value ? '   ' : ''); 
}

function formkeydown(form, event)
{
  check_lang(event);
  
  if (event.keyCode === 13 && event.target.classList.contains('autotab'))
  { 
    const at=form.querySelectorAll(":scope .autotab");	
    for(i = 0; i<at.length; i++)
	 if(at[i]==event.target)
	   if(next=at[i+1])
	   { next.focus();
   	     event.preventDefault();
	   }
  }
}

</script>


</form>

</body> <!-- workarea -->
</html>  