<?php
function html_color($c)
{
  $c = ($c >> 16) | ($c & 0xff00) | (($c & 0xff) << 16);
  return '#'.str_pad(dechex($c), 6, "0", STR_PAD_LEFT);
}

function color_html($s)
{ $c=hexdec(substr($s,1));
  return ($c >> 16) | ($c & 0xff00) | (($c & 0xff) << 16);
}


function zone_color($z, $col, $def='white')
{
 if($z==1) return 'var(--GlobalRed)'; 
 if($z==2) return 'var(--GlobalGreen)'; 
 if(is_null($col)) return $def;
 return html_color($col);
}

function zone_css($z, $col)
{ return ".zone$z { background-color: ".zone_color($z, $col)."}\r\n"; }

function color_background_style($col)
{
 if(is_null($col))
      return '';
 else return ' style="background: '.html_color($col).'"';   
}

