<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_HARDWARE);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'CARD_TYPE'; 
 	  public $visible= false;
    }, 
  
    new class extends DBLookupField
    { public $name = 'READER'; 
   	  public $data = true;
   	  public $caption = '  ';
	  public $query='select reader,read_name from D_DEVICES order by read_name';
    }
  ];   

    
  $sel='select r.card_type, r.reader, d.read_name from D_CARD_READERS r, D_DEVICES d
        where r.reader=d.reader  and r.card_type=:card_type';
		
  $this->select_sql =$sel.' order by d.read_name';   
  $this->refresh_sql=$sel.' and r.reader=:reader';
  $this->delete_sql ='delete from D_CARD_READERS where card_type=:card_type and reader=:reader';
  $this->insert_sql ='insert into D_CARD_READERS (card_type, reader) values (:card_type, :reader)'; 
 }
 
 
protected $error_map = ['D_CARD_READERS_PK' => '     ' ];  
 
 
 }; //TDataset