<?php
include_once "elacset.php"; 
include_once "options.php"; 

assert_right(RT_FUNCTIONS, RI_HARDWARE);

new class extends TDataset
{

 function get_tr_classes($row)  
 { if($row['CARD_TYPE']==0) return ['row-readonly'];  }

 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'CARD_TYPE'; 
   	  public $names= ['update' => 'NEWCT'];
      public $caption = '';
 	  public $data= true;
    },
    new class extends StringField
    { public $name = 'NAME';
      public $caption = ' ';  
  	  public $size=64;	  
    },	
    new class extends LookupField
    { public $name = 'MODE'; 
      public $caption = '';
	  public $title = '  ';
	  public $list=['  ', '', '']; 		  
	  public $default=1;
    },	
    new class extends BoolField
    { public $name = 'USE_NUM'; 
      public $caption = ' ';
	  public $title = '      ';
	  public $default=1;
    }	
  ];   
 
  $this->select_sql ='select * from D_CARD_TYPES order by card_type';   
  $this->refresh_sql='select * from D_CARD_TYPES where card_type=:card_type';
  $this->delete_sql ='delete from D_CARD_TYPES where  card_type = :card_type';
  $this->update_sql ='update D_CARD_TYPES 
                      set card_type= :newct, name = :name, mode = :mode, use_num=:use_num 
					  where card_type = :card_type';
      
  $this->insert_sql ='insert into D_CARD_TYPES(card_type,name, mode,use_num) values (:card_type, :name, :mode, :use_num)'; 
 }
 
 
protected $error_map = ['PRIMARY or UNIQUE KEY' => '   '];  
 
 
 }; //TDataset