<?php 
include "login.php"; 
include "options.php"; 
assert_right(RT_FUNCTIONS, RI_CLEARBASE);


$opt = new d_sid_option('dbclear/code');

if($_SERVER['REQUEST_METHOD']==='POST')
{
 if($opt->get()!=$_POST['checkcode']) fail('  ');
 $db->autocommit=false;
 $db->exec("insert into EVENTS (event_type,param1) values (131,$editor)");
 set_time_limit(0);
 
 if(isset($_POST['before']))
 {
  if(empty($_POST['date'])) fail(' ');
  $q=$db->prepare_execute('delete from EVENTS where datetime<:date', $_POST);
  $cnt=$q->rowCount();
  $db->commit(); 
  $db->beginTransaction();
  $q=$db->prepare_execute('select count(*) from EVENTS where datetime<:date', $_POST);
 }
 else
 if(isset($_POST['all']))
 {
  $cnt=$db->exec("delete from events");
  $db->commit();
  $db->beginTransaction();
  $db->query('select count(*) from EVENTS');
 }
 else
 if(isset($_POST['bad']))
 {
  $cnt=$db->exec("delete from EVENTS where datetime<'1.1.1971' or datetime>(cast('now' as date)+1)");
 }
 else
 if(isset($_POST['history']))
 {
  $cnt=$db->exec("delete from HISTORY");
  $db->commit();
  $db->beginTransaction();
  $db->query('select count(*) from HISTORY');
 }
 $db->autocommit=true;
 exit(" $cnt "); 
} 




//GET
$code=rand(100000, 999999);
$opt->set($code);
include "form.php"; 
?>
<link rel="icon" href="img/20.png">
<link rel="stylesheet" href="TButton.css">


<style>
#workarea.waiting {cursor: wait; }

#workarea.waiting #params {pointer-events: none;}			    
				   
#params {display: inline-block;
         padding: 0 1ch;
		 width: 60ch;   }
#code   {font-weight: bold;
         user-select: none; }		
		 
#params button { float: right; 
                 min-width: 20ch;
				 text-align: left; 
				 margin-bottom: 1em;
               }		 

#params hr {clear: both;}

</style>


<title> </title>

</head>
<body id=workarea>

<form id=params class=window>
<hr>
<button onclick="on_before()" type=button class=TButton><img src='img/20.png'><span>  </span></button>
   :<br>
<input type=date name=date>
<hr>
<button onclick="on_bad()" type=button class=TButton><img src='img/20.png'><span> </span></button>
       1970 ,        . <br>
<hr>
<button onclick="on_all()" type=button class=TButton><img src='img/20.png'><span> </span></button>
    . <br>
<hr>
<button onclick="on_history()" type=button class=TButton><img src='img/20.png'><span> </span></button>
  .<br>
<hr>
    : <output id=code><? echo $code ?></output><br>
<input size=6 name=checkcode required>
<hr>
</form>

<script>
function exec_cmd(cmd)
{
  var fd=new FormData(params);
  fd.set(cmd,1);

  var xhr = new XMLHttpRequest;
  xhr.onreadystatechange = 
  function() 
  {
    if(this.readyState==4)   alert(this.responseText); 
    workarea.classList.toggle('waiting', this.readyState<4);
  }    

  xhr.open('POST', '');  
  xhr.send(fd);
}

function on_before()
{
  params.date.setCustomValidity(params.date.value ? '' : '  ');
  if(!params.reportValidity()) return;
  if(confirm("       "+params.date.value+" ?")) 
    exec_cmd('before'); 
}

function on_bad()
{
  if(!params.reportValidity()) return;
  if(confirm("    '' ?")) 
    exec_cmd('bad');
}

function on_all()
{
  if(!params.reportValidity()) return;
  if(confirm("     ?"))
     exec_cmd('all');
}

function on_history()
{
  if(!params.reportValidity()) return;
  if(confirm("      ?")) 
    exec_cmd('history');
}
</script>



</body> <!-- workarea -->
</html>  