<?php
include_once('vendor.php');

$models = [3 => VENDOR_DEVICE_NAME,
           2 => 'El-C800V',
		   1 => 'El-C800K',
		   0 => 'El-C800',
		  -1 => '']; 
		  
$el05modes=
[ 1 => '  ',
  2 => ' ',
  3 => '',
  4 => '',
  5 => '.   ',
  6 => '   ',
  7 => ' ',
  8 => '',
  9 => ''];
  

$el05read =  [0 => '',
              1 => 'Wiegand',
              6 => 'Wiegand   ',
              7 => 'Wiegand   ',
              2 => 'TouchMemory',
              3 => 'UEM',
              4 => ' Citizen PPU-700',
              5 => ' CRT-530',
              8 => 'Wieagand PR-P16',
			  9 => '',
			  10 => 'PERCo AT01'];
  
const ENTER_COUNT=6*2;   
  
$enter_names=["DOOR1","BUTN1","BLOCK1","UNBL1","IN1.1","IN1.2",
              "DOOR2","BUTN2","BLOCK2","UNBL2","IN2.1","IN2.2"];
		 
$enter_modes=["", ".-", ".-"];
  

function get_def_enters($mode)
{
 $def_enters=[2,1,1,1,0,0,2,1,1,1,0,0];  
 if($mode==5 || $mode==7) // 0x05 -     0x07 -  
 { $def_enters[0]=0; //DOOR1  
   $def_enters[6]=0; //DOOR2   
 }
 return $def_enters;
}
  
$speeds = ['','2400','3600','4800','7200','9600','14400','19200','28800','38400','57600','115200']; 

$lpt_types = ['', 'WH1602'];


$local_apb = [0 => '',
              1 => ', ',
              2 => ', ',
              5 => '',
              6 => ''];


const TIMER_COUNT=8; 

function el05timer_names($mode, $rlist)
{
$tnames=[];
for($i=0; $i<TIMER_COUNT; $i++)
 $tnames[]="  $i";

 
switch($mode) 
{ case 1:  $tnames[0]="  1"; 
           $tnames[1]="  1";
		   $tnames[2]="  2";
		   $tnames[3]="  2";
           break;
  case 2:  $tnames[0]=" "; 
           $tnames[1]=" ";		   
		   break;		   
  case 3:  $tnames[0]="  "; 
           $tnames[1]=" ";		   
		   break;		   
  case 4:  $tnames[0]="  "; 
           $tnames[1]="  ";	
		   $tnames[2]="  ";	   
		   break;	
  case 5:  $tnames[0]="  ''"; 
           $tnames[1]=" ";	
		   $tnames[2]="  ''";	   
		   $tnames[3]="  ";
		   $tnames[4]="   ";
		   break;			   	   
  case 6:  $tnames[0]="  ''"; 
           $tnames[1]=" ";	
		   break;			   	   
  case 7:  $tnames[0]="  ''"; 
           $tnames[1]=" ";	
   		   $tnames[2]="  ''";	   
		   $tnames[3]="  ";
		   $tnames[4]="   ";
		   $tnames[5]="   ";
		   $tnames[6]="   ()  ";
		   break;			   	   
   case 8: $tnames[5]="   ";		   
		   $tnames[6]="     1";
		   $tnames[7]="     2";
		   break;  
}


if(in_array(9,$rlist))  $tnames[4]="   ";
if(in_array(10,$rlist)) $tnames[4]="  ";
return $tnames;
}


$el05def_timers = //[ 0..7] [ ]
[ 1 => [5,15,5,15],
  2 => [5,15],
  3 => [5,15],
  4 => [5,15],
  5 => [2,30,2,20,2],
  6 => [20,30],  
  7 => [2,30,2,20,2,5,20],
  8 => [0,0,0,0,0,5,20,20],
  9 => []
];



function el05side_name($mode, $side) 
{
  switch($mode)
   { case 1: return ' '.$side+1; 
     case 2: return '';
	 case 3: return ' '.$side+1; 
	 case 4: return ' '; 
    default: return ' ';
   }	 
}
 
 
function el05calcside($mode, $schit)
{
 if(in_array($mode, [1,8,3])) //   // //
      return $schit % 2;
 else return 0;
}
 