<style>
.device:not([data-ip])    .POPUP_IP,
.device:not([data-el05])  .POPUP_EL05,
.device:not([data-vm])    .POPUP_VM    {display: none}
</style>


<link rel="stylesheet" href="popup.css">
<script src="popup.js"></script>

<script>

function get_popup_node(menu_item)
{ return menu_item.parentNode.parentNode;
  //menu_item.parentNode.popup_node.parentNode;
}

function get_popup_data(menu_item, names)
{ var n=get_popup_node(menu_item);
  let params=[];
  names.forEach( function(s) {params.push(s+"="+n.dataset[s])} );
  return params.join('&');
}


function ph_command(item, cmd)
{ var xhr = new XMLHttpRequest();
  xhr.open('POST', phmodule_http(get_popup_node(item).dataset.ip, cmd), false);
  xhr.send();	
  if(xhr.status!=200)  alert(": "+xhr.responseText );
}



function post_command(uri, fd)
{ var xhr = new XMLHttpRequest();
  xhr.open('POST', uri, false);
  if(fd)  xhr.send(fd);    
    else  xhr.send();
	
  if(xhr.status==200) 
     setTimeout(update_queue, 1000);
  else
  {  alert(": "+xhr.responseText );
     throw xhr.responseText;
  }  
}



function comp_text(it, cmd)
{
  const params={ cmd:   cmd,
                 title: get_popup_node(it).dataset.name+": "+it.innerText };
  dataarea_load(it, `diag_text.php`, params);	   
}

var dataarea_object=null;

function dataarea_load(item, url, params)
{
  var xhr = new XMLHttpRequest;
  xhr.open('GET', url, false);
  xhr.send();
  load_form(dataarea, xhr);  
  
  if(title=dataarea.querySelector(":scope>.title"))
    title.insertAdjacentHTML('beforeend', '<div class=winclose title=" "  onclick="dataarea_close()"></div>');  
  
  if(dataarea_object) 
    dataarea_object.create(get_popup_node(item), params);
}

function dataarea_close()
{
 if(dataarea_object && dataarea_object.close) dataarea_object.close();
 dataarea_object=null;
 dataarea.innerHTML='';
}
</script>

<!---------------------------------------------------------------------------------------------------------->
<!--  -->

<div class=popup id=comp_popup>
 <div onclick="dataarea_load(this,'diag_phlog.php')" class=RI_HARDWARE><img src='img/41.png'><span>. </span></div> 

 <div onclick="dataarea_load(this, 'diag_ping.php?'+get_popup_data(this, ['ip']))">
                            <span>ping...</span></div> 

 <div onclick="ph_command(this, 'phmodule/restart')" class=RI_HARDWARE>   
                            <span> .</span></div>							
 <hr>
 <div onclick="dataarea_load(this, 'diag_events.php?'+get_popup_data(this, ['computer']))" class=RI_EVENTSBASE>
     <img src='img/d10.png'><span> </span></div>
	 
 <div onclick="dataarea_load(this, `diag_events.php`)" class=RI_EVENTSBASE>
     <img src='img/d10.png'><span> </span></div>
 <hr>
 <div onclick="dataarea_load(this, 'diag_cmds.php?'+get_popup_data(this, ['computer']))">
                            <span>  </span></div> 
							
 <div onclick="post_command('diag_clear.php?'+get_popup_data(this, ['computer']))+'&addr=-1')" class=RI_HARDWARE>   
      <img src='img/d6.png'><span>  </span></div>
	  
 <hr>
 <div onclick="comp_text(this, 'config')" class=RI_HARDWARE><span>config.ini</span></div>  
 <div onclick="comp_text(this, 'logtxt')" class=RI_HARDWARE><span>log.txt</span></div> 
 <div onclick="comp_text(this, 'logold')" class=RI_HARDWARE><span>log_old</span></div> 
 <hr>
 
 <div onclick="comp_text(this, 'license')" class=RI_HARDWARE><span></span></div>  
 <div onclick="comp_text(this, 'serial')" class=RI_HARDWARE><span> </span></div>  
 
							
</div>
<!---------------------------------------------------------------------------------------------------------->
<!--  -->

<div class=popup id=dev_popup>
 <div onclick="dataarea_load(this, 'diag_set.php?'+get_popup_data(this, ['computer', 'reader']))" class=RI_HARDWARE>
     <img src='img/26.png'><span></span></div> 

 <div onclick="dataarea_load(this, 'diag_events.php?'+get_popup_data(this, ['computer', 'addr']))" class=RI_EVENTSBASE>
     <img src='img/d10.png'><span> </span></div> 
 <hr>
 <div onclick="post_command('diag_time.php?'+get_popup_data(this, ['computer', 'addr']))">
      <img src='img/d5.png'><span> </span></div>
 <div onclick="dataarea_load(this, 'diag_cmds.php?'+get_popup_data(this, ['computer', 'addr']))"> 
                            <span>  </span></div> 
 <div onclick="post_command('diag_clear.php?'+get_popup_data(this, ['computer', 'addr']))" class=RI_HARDWARE> 
      <img src='img/d6.png'><span>  </span></div>
 <div onclick="post_command('diag_reload.php?'+get_popup_data(this, ['reader']))" class=RI_HARDWARE>
                            <span> </span></div>
 <div onclick="dataarea_load(this, 'diag_fw.php?'+get_popup_data(this, ['computer', 'addr']))" class="RI_HARDWARE POPUP_EL05">
                            <span>...</span></div>
 <div onclick="dataarea_load(this, 'diag_ping.php?'+get_popup_data(this, ['ip']))" class=POPUP_IP>
                            <span>ping...</span></div> 
 <div onclick="dataarea_load(this,'diag_addr.php?'+get_popup_data(this, ['computer', 'addr']))" class="POPUP_EL05 RI_HARDWARE"> 
                            <span> el-net...</span></div> 							
 <div onclick="dataarea_load(this, 'diag_ip.php?'+get_popup_data(this, ['computer', 'addr']))" class="POPUP_EL05 RI_HARDWARE">
                            <span> Ethernet...</span></div> 							

 <div onclick="dataarea_load(this, 'diag_move.php?'+get_popup_data(this, ['computer', 'addr']))" class=RI_HARDWARE> 
                            <span>  ...</span></div> 							

 <div onclick="dataarea_load(this, 'diag_vm.php?'+get_popup_data(this, ['computer', 'addr']))" class="POPUP_VM RI_HARDWARE"> 
       <img src='img/3.png'><span> ...</span></div>			

							
 <hr>
 <div onclick="post_command('diag_open.php?'+get_popup_data(this, ['computer', 'addr']))" class=RI_OPEN_DOOR>
       <img src='img/d8.png'><span> </span></div>
	   
 <div onclick="dataarea_load(this, 'diag_ver.php?start&+'+get_popup_data(this, ['computer', 'addr']))">
                             <span> </span></div> 
</div> 
<!---------------------------------------------------------------------------------------------------------->
<!--  -->

<div class=popup id=schit_popup>
 <div onclick="dataarea_load(this, 'diag_set.php?'+get_popup_data(this, ['computer', 'reader']))" class=RI_HARDWARE>
     <img src='img/26.png'><span></span></div> 
	 
 <div onclick="dataarea_load(this, 'diag_events.php?'+get_popup_data(this, ['reader']))" class=RI_EVENTSBASE>
      <img src='img/d10.png'><span> </span></div>
 <hr>
 <div onclick="post_command('diag_open.php?'+get_popup_data(this, ['computer', 'addr', 'schit']))" class=RI_OPEN_DOOR>
       <img src='img/d8.png'><span> </span></div>
</div> 
<!---------------------------------------------------------------------------------------------------------->

 
<script>
document.addEventListener("DOMContentLoaded", function()  
{  
   for(let n of document.querySelectorAll('.computer > label, .computer > span'))
        attach_popup(n, comp_popup);
 
   for(let n of document.querySelectorAll('.device > label'))
        attach_popup(n, dev_popup);  

   for(let n of document.querySelectorAll('.schit > span'))
        attach_popup(n, schit_popup);
   
   diagtree.oncontextmenu =  function(e){e.preventDefault();};    
 
   setInterval(on_update_timer, 10000); 
   
   update_queue();
});

</script>
