<?php
include_once "system.php"; 
include_once "login.php"; 
include_once "dataset.php";  


class ColorField extends IntField
{ 
  function get_data_text($v) 
  { return html_color($v ?? 0xffffff); }	  
	  
  function parse($v)
  { if($v=='') return null;
    $c=color_html($v);	  
    return $c==0xffffff ? null : $c;
  }	  
}	