//https://gist.github.com/p3t3r67x0/ac9d052595b406d5a5c1

// style-,    ,    
function excel_table(table, style, worksheet) //return url to download
{
  let   caption=table.querySelector(":scope>caption"),
        body=table.querySelector(":scope>tbody").outerHTML,
        head=table.querySelector(":scope>thead").outerHTML;			
  
  if(caption && caption.classList.contains('TNav')) caption=null;
  
  let style_text='';    
  if(typeof style=="string") 
   for(let st of document.getElementsByClassName(style))
     style_text+=st.innerHTML+"\r\n";
  else
   if(style) style_text=style.innerHTML;
   
  
			
  const xls=
`<html xmlns:o="urn:schemas-microsoft-com:office:office" xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40">
<head>
<!--[if gte mso 9]>
<xml>
  <x:ExcelWorkbook>
     <x:ExcelWorksheets>
	   <x:ExcelWorksheet>
	      <x:Name>${worksheet ? worksheet : document.title}</x:Name>
	      <x:WorksheetOptions>
		    <x:DisplayGridlines/>     
		  </x:WorksheetOptions>
       </x:ExcelWorksheet>
	 </x:ExcelWorksheets>
  </x:ExcelWorkbook>
</xml>
<![endif]-->

<style>
${style_text}
</style>

</head>
<body>
<table border=1 id=${table.id}>
${caption ? caption.outerHTML : ''}
${head}
${body}
</table>
</body>
</html>`;  
  
 return URL.createObjectURL(new Blob([xls], {type : 'application/vnd.ms-excel'}));
}
//https://stackoverflow.com/questions/61878615/exporting-to-excel-with-color-style
