<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_GROUPS);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name = 'NUM'; 
      public $caption = '';
 	  public $data= true;
	  public $visible=false;
      public $generator='GEN_GROUPS';
    },
    new class extends StringField
    { public $name = 'GROUPNAME';
      public $caption = ' ';  
  	  public $size=64;	  
    },	
    new class extends IntField
    { public $name = 'CNT'; 
      public $caption = '';
	  public $readonly = true;
    }	
  ];   
  $sel = "select num, groupname, (select count(*) from USERS where usergroup=GROUPS.num) as cnt from GROUPS ";
  $this->select_sql =$sel.'order by groupname';   
  $this->refresh_sql=$sel.'where num=:num';
  $this->delete_sql ='delete   from GROUPS where num=:num';
  $this->update_sql ='update GROUPS set groupname = :groupname where num=:num';
  $this->insert_sql ='insert into GROUPS (num, groupname) VALUES (:num, :groupname)'; 
 }
 
protected $error_map = 
	['FOREIGN KEY' => ' '];  
 
 
 }; //TDataset