<?php
include "system.php";
include "login.php";
include "colors.php";

assert_right(RT_FUNCTIONS, RI_MASS_UPDATE);

if($_SERVER['REQUEST_METHOD']==='POST')
{ $db->autocommit=false;	 
  extract($_POST); //$select, $cont, $$select, $set, $$set
  $where=''; 
  switch($select)
  { case 'selgroup': $where='usergroup'; break;
    case 'selcolor': $where='color';
	                 if($$select=='null') 
	                 { $where.=' is';
					   if($cond) $where.=' not';
					   $where.=' null';
					   unset($$select);
					   unset($cond);
					 }
	                 break;
    case 'selact':   $where='act_date'; break;
	case 'seldas':   $where='das_date'; break;
	case 'selall':   break;
	default: fail('Unknown select');
  }

  if(isset($cond))
  switch($cond)
  { case 0: $where.='=';  break;
    case 1: $where.='!='; break;
  }
  
  $params=[];
  if(isset($$select))
  { $where.='?';
    $params[]=$$select;
  }
	
  if($where) $where=' and '.$where;  
  $where = "select num from USERS, D_OWNERS where num=user_ref $where".sql_where(" and usergroup",RT_GROUPS);
	
	
  $q=$db->prepare($where);	
  $q->execute($params);	
  $nums = $q->fetchAll(PDO::FETCH_COLUMN);   	 
	
  if($action=='count') echo sizeof($nums);  
  else
  if($action=='apply')
  { 
    switch($set)
	{   	
	  case 'setlevel': assert_right(RT_USERPROPS, RU_LEVEL);
	                   $upd="update D_OWNERS set acc_lev =:$set where user_ref=:num".sql_where(" and acc_lev",RT_LEVELS); break;
	  case 'setcolor':
	  case 'setxcolor': assert_right(RT_USERPROPS, RU_COLOR);
   	                    if($$set=='null') $$set=null;  else
					    if(str_starts_with($$set, '#')) $$set=color_html($$set);
	                    $upd="update D_OWNERS set color   =:$set where user_ref=:num"; break;			   					   
	  case 'setact':   assert_right(RT_USERPROPS, RU_PERIOD);
	                   $upd="update D_OWNERS set act_date=:$set where user_ref=:num"; break;
	  case 'setdas':   assert_right(RT_USERPROPS, RU_PERIOD);
	                   $upd="update D_OWNERS set das_date=:$set where user_ref=:num"; break;
	  case 'setgroup': assert_right(RT_USERPROPS, RU_GROUP); 
	                   $upd="update USERS set usergroup=:$set   where num=:num"; break;
	  default: 
	    if(str_starts_with($set, 'setprop_'))
		{ $prop_id=intval(explode('_',$set)[1]);
   		  assert_right(RT_USERPROPS, $prop_id);
		  $upd="update USER_PROPS set prop_value=:$set where prop_id=$prop_id and user_num=:num";
		}	
	}

    $params=[$set => $$set];
	$q=$db->prepare($upd);
	$cnt=0;
	foreach($nums as $n)
	{
	  $params['num']=$n;
      $q->execute($params);	
	  $cnt+=$q->rowCount();
	}
	echo($cnt);	  
  }  	 
  
  $db->commit();   
  exit();  
}
?>

<form id=mass_form class=ToolForm  onreset="btnmass.classList.remove('ToolDown')">

<style>
#mass_form {padding: 10px; 
            line-height: 2;
     	   }

#mass_form .TButton {margin-right: 10px; }

#mass_form>div>span:first-child { display: inline-block;
                                  width: 15ch;  }

#mass_form [name='cond']:disabled,
#mass_form [name='set']:invalid+span  { visibility: hidden; }

[name]:enabled~#massvaluestub,
#mass_form *:disabled   {display: none;}

#massvaluestub {width: 20ch;
                display: inline-block;  }
				
#mass_form [name='selcolor'],
#mass_form [name='setcolor']  { width: 10ch; }


				
</style>

<script>
function on_mass_select_change(value)
{ for(let s of massvalue.querySelectorAll(":scope>[name]"))
     s.disabled= s.name!=value;

  mass_form.cond.disabled=!massvalue.querySelector(":scope>[name]:enabled");	 	 
}
</script>

<div>
<span> </span> 
<select name=select onchange="on_mass_select_change(this.value)" required>
  <option value='' disabled selected></option>
  <option value=selgroup></option>
  <option value=sellevel> </option>
  <option value=selcolor></option>
  <option value=selact> </option>
  <option value=seldas> </option>
  <option value=selall></option> 
</select>

<select name=cond disabled required>
 <option value='' disabled selected></option>
 <option value=0></option>
 <option value=1> </option>
</select> 

<span id=massvalue>
<select name=selgroup title=" " required disabled>
<option value='' selected disabled></option>
<?php
$groups = $db->query("select num,groupname from groups ".sql_where("where num",RT_GROUPS)." order by groupname")->fetchAll();
foreach($groups as [$num, $name])
  echo "<option value=$num>$name</option>\r\n";
?> 
</select>

<select name=sellevel title="  " required disabled>
<option value='' selected disabled></option>
<?php
$levels=$db->query('select  A_LEVEL,A_NAME from D_ACCESS_LEVELS '.sql_where(' where A_LEVEL',RT_LEVELS).' order by A_LEVEL')->fetchAll();
foreach($levels as [$num, $name])
  echo "<option value=$num>$num  $name</option>\r\n";
?> 
</select>

<select name=selcolor title=" " required disabled 
        onchange='this.style.backgroundColor=this.options[this.selectedIndex].style.backgroundColor'>
<option value='' selected disabled></option>
<?php
$colors=$db->query('select distinct color from D_OWNERS order by 1')->fetchAll(PDO::FETCH_COLUMN);
foreach($colors as $col)
  if(is_null($col))
        echo "<option value=null style='background: white'></option>\r\n";
   else echo "<option value=$col style='background: ".html_color($col)."'></option>\r\n";
?> 
</select>

<input name=selact type=date required disabled>
<input name=seldas type=date required disabled>
<span id=massvaluestub></span> 
</span> <!-- massvalue -->
</div>

<div>
<span></span>

<script>
function on_mass_set_change(value)
{ for(let s of massset.querySelectorAll(":scope>[name]"))
     s.disabled = s.name!=value;
}
</script>


<select name=set onchange="on_mass_set_change(this.value)" required>
 <option value='' selected disabled></option>
<? if(has_right(RT_USERPROPS, RU_LEVEL)) {?> <option value=setlevel> </option> <? } ?>
<? if(has_right(RT_USERPROPS, RU_COLOR)) {?> <option value=setcolor> ()</option>          
                                             <option value=setxcolor> ()</option>   <? } ?>
<? if(has_right(RT_USERPROPS, RU_PERIOD)) {?><option value=setact> </option>  
                                             <option value=setdas> </option>  <? } ?>
<? if(has_right(RT_USERPROPS, RU_GROUP)) {?> <option value=setgroup></option>          <? } ?>
 
<?php  
 $props = $db->query("select id, prop_name from USER_PROP_TYPES order by id")->fetchAll(); 
 foreach($props as [$id, $name])
   if(has_right(RT_USERPROPS, $id))
    echo "<option value=setprop_$id>$name</option>\r\n";   
?> 
</select> 

<span> </span>

<span id=massset>
<select name=setlevel title="  " required disabled>
<option value='' selected disabled></option>
<?php
foreach($levels as [$num, $name])
  echo "<option value=$num>$num  $name</option>\r\n";
?> 
</select>

<select name=setcolor title=" " required disabled 
        onchange='this.style.backgroundColor=this.options[this.selectedIndex].style.backgroundColor'>
<option value='' selected disabled></option>
<?php
foreach($colors as $col)
  if(is_null($col))
        echo "<option value=null style='background: white'></option>\r\n";
   else echo "<option value=$col style='background: ".html_color($col)."'></option>\r\n";
?> 
</select>

<input name=setxcolor type=color title="  " required disabled>

<input name=setact type=date required disabled>
<input name=setdas type=date required disabled>


<select name=setgroup title=" " required disabled>
<option value='' selected disabled></option>
<?php
foreach($groups as [$num, $name])
  echo "<option value=$num>$name</option>\r\n";
?> 
</select>

<?php  
 foreach($props as [$id, $name])
   if(has_right(RT_USERPROPS, $id))
    echo "<input type=text name=setprop_$id disabled>\r\n";   
?> 
</span> <!-- massset -->

</div>

<button type=button class=TButton onclick="on_mass_apply()"><img src="img/ok.png"><span></span></button>
<button type=reset class=TButton><img src="img/cancel.png"><span></span></button>

<script>
function on_mass_apply()
{ if(!mass_form.reportValidity()) return;
  var xhr = new XMLHttpRequest();
  xhr.open('POST', 'massedit.php', false);  
  var fd=new FormData(mass_form);
  fd.set('action','count');  
  xhr.send(fd);

  if(xhr.status==200) 
  { 
    if(!confirm(" "+xhr.responseText+" .\r\n"+" ?")) return;
	fd.set('action','apply');  
	xhr.open('POST', 'massedit.php', false);  
    xhr.send(fd);
    if(xhr.status==200) {mass_form.reset();
						 table_reopen(users);
						 alert('  '+xhr.responseText+" .");
						 return; 
						}
  }
  
  alert(": "+xhr.responseText);
}
</script>

</form>