<?php
class TreeMenuBuilder
{
 private $root_cnt=0;
 private $level=0;
 private function pad() {return str_repeat(' ', $this->level * 2); }
 private $child_count=[0];
 

 function node($name, $img)
 { ob_start();
   $id = 'menu'.$this->root_cnt;   
   echo $this->pad(), "<li><input type=checkbox id=$id>",
        "<label for=$id><img src='img/$img.png'>$name</label>", "\r\n";
   echo $this->pad(), "<ul>", "\r\n";       
   $this->root_cnt++;
   $this->level++;
   $this->child_count[]=0; //push back child counter
 }

 function end()
 { $this->level--;
   echo $this->pad(), '</ul>', "\r\n", '</li>', "\r\n";   
   
   if(array_pop($this->child_count))
         { $this->child_count[count($this->child_count)-1]++; 
		   ob_end_flush();
		 }  
	  else ob_end_clean();   	  
 }

 
 function add($name, $img, $uri = '#/', $visible=true, $attr='')
 { if(!$visible) return;
   echo $this->pad(), "<li><a href='$uri' $attr><img src='img/$img.png'>$name</a></li>", "\r\n"; 
   $this->child_count[count($this->child_count)-1]++; 
 }

}
