<?php
include_once "system.php";
include_once "login.php";
include_once "right_base.php";

$oper = intval($_GET['editor']);

function draw_rt_list($rt)
{
 global $get_right_list, $db, $oper;
 
 $rights = $db->query("select right_type,right_id from D_EDITOR_RIGHTS where editor=$oper")->fetchAll(PDO::FETCH_NUM); 
  
 if(isset($get_right_list[$rt]))
 foreach($get_right_list[$rt]() ?? [] as $id=>$name)
 {$disabled = in_array([$rt, $id], $rights) ? "disabled" : '';
  echo "<label>
        <input type=radio name=radd $disabled>
		<div data-editor=$oper data-right_type=$rt data-right_id=$id draggable=",$disabled ?  'false' : 'true',">$name</div></label>";  
 }		
}


if($_SERVER['REQUEST_METHOD']==='POST')
{ draw_rt_list(intval($_GET['rt']));
  exit();
}
?>

<div id=raddarea>
<style>
#raddarea:empty {display: none;}
		  
#radd>* {cursor: grab;  }		  
</style>

<script>
function on_rt_change(rt)
{
  var xhr = new XMLHttpRequest();
  xhr.open('POST', 'oper_radd.php?rt='+rt+'&editor='+oper, false); 
  xhr.send();  
  radd.innerHTML=xhr.responseText;
}
</script>

<div class=TNav>
<span id=btn_radd class='ToolBtn NavBtn ToolDisabled' title='   '
      onclick="if(oper!=1) on_add_right(radd.querySelector(':scope input:checked+div'))"><img src='img/navnew.png'></span>
<select onchange="on_rt_change(this.value)" title="  ">
<?
foreach($right_types as $rt=>$name)
 if(has_right(RT_RIGHTS,$rt))
  echo "<option value=$rt", $rt==RT_FUNCTIONS ? ' selected' : '',">$name</<option>";
?>
</select>


</div>

<div id=radd class=TList onchange="btn_radd.classList.remove('ToolDisabled')" 
     ondragstart="this.drag_item=event.target"
     ondragover="if(oper!=1) event.preventDefault()" 
     ondrop="on_del_right(rdel.drag_item);">

<? draw_rt_list(RT_FUNCTIONS) ?>
</div>

 
 
</div> <!-- raddarea -->

