<?php 
include_once('system.php');
include_once('login.php');
include 'options.php';
include 'phid_opt.php';
assert_right(RT_FUNCTIONS, RI_PHOTOID); 



if($_SERVER['REQUEST_METHOD']==='POST')
{
  $db->autocommit=false;
  $db->exec("delete from D_PHOTOID_READERS where editor_ref=$editor");
  $q=$db->prepare("insert into D_PHOTOID_READERS (editor_ref, reader_ref) values($editor, ?)");
  foreach(array_keys($_POST['reader']) as $r)
    $q->execute([$r]);
  
  $db->prepare_execute("update D_EDITOR_SETTINGS set photoid_delay=:photoid_delay where editor=$editor", $_POST);	
  
  post_options('opts');
  
  $db->autocommit=true;	
  header("Location: photoid.php");
  exit;
}

//GET
include "form.php"; 
include 'formdraw.php';
include 'TNav.php';
include 'table.php';




extract($db->query("select PHOTOID_DELAY from D_EDITOR_SETTINGS where EDITOR=$editor")->fetch(PDO::FETCH_ASSOC));

?>

<link rel="icon" href="img/5.png">

<title> </title>

<style>
#phid_cfg {display: inline-block;}

#readers { background: white; 
           overflow: auto;
		   max-height: 10em;
		   border: 1px solid black;
         }
#readers>label {display: block;}

#readers input:checked+span { font-weight: bold;}

input[type='number'] {width: 7ch; 
                      text-align: right;}
					  
#opts input[type='checkbox'] { margin-left: 0 }
					  
</style>


</head>

<body id=workarea>
<form id=phid_cfg class=table method=POST>
<div class=TNav>
<button type=submit class='ToolBtn NavBtn ts_edit' title=' '><img src='img/navpost.png'></button
><? nav_form_cancel(); nav_label(); ?>
</div>
<div>

<div id=opts>
<input type=number <? draw_value('PHOTOID_DELAY')  ?> min=1 max=99 required>    (.)<br>
<input type=number <? draw_option('opts','X')   ?> min=1 max=99 required>     <br>
<input type=number <? draw_option('opts','Y')   ?> min=1 max=99 required>     <br>
<input type=number <? draw_option('opts','R') ?> min=1 max=9 step='0.1' required>   (/)<br>
<label><? draw_check_option('opts','EV') ?>      </label>
</div> <!-- opts -->

<hr>

 :
<div id=readers>
<?
foreach($db->query("select reader, read_name, iif(reader_ref is null, 0,1)  from D_ABSTRACT_READERS
                    left join D_PHOTOID_READERS on reader=reader_ref and editor_ref=$editor 
					order by 3 desc, 2") as $row)
  echo "<label><input type=checkbox name='reader[$row[0]]'", $row[2] ? ' checked' : '',"><span>$row[1]</span></label>";
?>
</div> <!--readers-->


</div>
</form>
</body>
</html>  