<?php
include_once('login.php');
include_once('formdraw.php');
include_once('TNavDef.php');
include_once('WF3.php');
include_once('colors.php');

assert_req_right();


if(isset($_GET['requisition'])) //edit
{extract($db->prepare_execute("
   select r.*,u1.username as guestname,u2.username as initiatorname,g.groupname as initiatorgroupname,
          (r.visit_date+r.visit_days-1) as visit_last_date, (r.visit_date+r.visit_days) as visit_end_date,
		  cast('now' as date) as now,
		  l.a_name as level_name,
          gd1.data_value as guestorg, 
		  u1.photo_update_time,
		  tc.card_num,
          s.state_name,e.editor_name, o.user_ref, rt.name as rt_name, rt.color as rt_color from D_REQUISITIONS r
   left join USERS u1 on r.guest=u1.num
   left join USERS u2 on r.initiator=u2.num
   left join D_EDITOR_SETTINGS e on r.editor=e.editor
   left join GROUPS g on g.num=u2.usergroup
        join D_REQUISITION_STATES s on r.state=s.state
   left join D_OWNERS o on o.user_ref=r.guest
   left join D_ACCESS_LEVELS l on l.a_level=r.rench_level
   left join D_REQ_TYPES rt on r.req_type=rt.id
   left join D_GUEST_DATA gd1 on gd1.guest=r.guest and gd1.data_type=1
   left join D_TMP_CARDS tc on tc.requisition=r.requisition
   where r.requisition=:requisition", $_GET)->fetch(PDO::FETCH_ASSOC));
   
   if(isset($_GET['copy']))
   {
     $REQUISITION = 0;
	 $AIM=null;
   }
   
}   
else //new
{
 $REQUISITION = 0;
}

extract($db->query("select guest_required_aim, guest_pers_code, req_deflevel from D_SETTINGS")->fetch(PDO::FETCH_ASSOC));


$giveform=isset($_GET['give']);
$readonly = !$REQUISITION || $STATE==0 && $EDITOR==$editor && !$giveform ? '' : ' readonly';

?>

<form id=reqform 
      class="window screen_center fix-height <? echo $REQUISITION ? 'ts_selected' : 'ts_insert'?>" 
      autocomplete=off  spellcheck=false tabindex="-1" 
	  onreset="table_show_form(this)"
	  on_table_before_post="req_before_post()"
	  >
<div class=title><? if($REQUISITION) echo ' ',$REQUISITION; 
                               else  echo ' ';?>
                 <div class='winclose formclose' title="" onclick="table_close_form(reql)"></div>
</div>

<script>
function req_before_post()
{
  if(!reqform.GUEST.value)
    reqform.GUESTNAME.setCustomValidity('  '); 
}
</script>


<style>
#reqform td.TNav { border: none;}								   
#reqhidden {color: red;}
#reqform.ts_insert .noinsert  {visibility: hidden;}

#reqform [name=NOTES] 
    { width: 100%;
      resize: vertical;
    }
	
#reqform td {white-space: nowrap;}	
	
#reqform [name=INITIATORNAME],
#reqform [name=GUESTNAME],
#reqform [name=AIM]  { width: 30ch;}		   	 	
#reqform [name^=DATA] { width: 100%;}
#reqform {z-index: 100;}

#reqcolor   { min-width:  22em;
              position: relative;
     	      border: 1px solid gray;
			  border-radius: 3px;
            }
		   
#reqphoto { max-height: 95%;
              max-width: 95%;
  		    }
		  
#cardrow input {width: 6ch; }


</style>							   
							   

<? include_once('filt_users.php'); ?>

<table>

<tr>
<td class=TNav colspan=2>
<? 
 if(!$readonly)
 { 
   nav_new();
   if($REQUISITION && has_right(RT_FUNCTIONS,RI_CANCELREQ) &&  $STATE==0 && $editor==$EDITOR)
      nav_del(['onclick'=>'req_delete()', 'img'=>'img/navdel.png', 'title'=>' ']);   
   nav_post();  
   nav_cancel();
   
   if($REQUISITION && has_right(RT_FUNCTIONS,RI_EVENTSBASE))
    echo "<a href='events.php?nomenu&all&user=$GUEST",
	     "&start_date=",(new DateTime($VISIT_DATE))->format('Y-m-d'),
		 "&end_date=",  (new DateTime($VISIT_END_DATE))->format('Y-m-d'),
		 "' target=_blank class='ToolBtn NavBtn ts_selected' title='   '><img src='img/15.png'></a>";
   
   nav_label();
 }  ?>
</td>

<td id=reqcolor rowspan=0>
<img id=reqphoto class=screen_center <? if(isset($GUEST)) echo $db->photo_img_src($GUEST, $PHOTO_UPDATE_TIME)?> alt=''>
</td>

</tr>

<tr class=noinsert>
<td> </td>
<td><input readonly size=4 <? if($REQUISITION) draw_value('REQUISITION') ?>">
<? if($HIDDEN ?? 0) { ?> <span id=reqhidden title="     ">[]</span> <? } ?>
</td>
</tr>

<tr class=noinsert>
<td></td>
<td><input readonly size=10 value="<? echo $STATE_NAME ?? ''?>" style="background: <? echo $req_state_colors[$STATE ?? 0]?>">
</td></tr>

<? 
if($types = $db->query("select ID, NAME from D_REQ_TYPES order by id")->fetchAll(PDO::FETCH_NUM))
{ ?>
<tr>
<td> </td>
<td>
<? 
  if($readonly)
       echo "<input readonly value='$RT_NAME'",color_background_style($RT_COLOR), '>';
  else draw_lookup('REQ_TYPE', array_merge([[null, '']],  $types), 
                   'required onchange="on_type_change(this.value)"');   ?>
<script>
function on_type_change(t)
{ for(let n of reqform.querySelectorAll(':scope [data-rt]'))
  {
    n.disabled=n.dataset.rt!=t;
	n.closest('tr').style.display = n.disabled ? 'none' : '';
  }    
}

on_type_change('<? echo $REQ_TYPE ?>'); //init on load
</script>


</td>
</tr>
<? }  //if($types?>


<tr><td></td>
<td><input readonly <? draw_value('GUESTORG') ?>></td></tr>


<tr><td> </td>
<td>
<? if($readonly)  {echo "<input readonly "; draw_value('GUESTNAME'); echo ">"; }
   else { ?>
    <input type=hidden <? draw_value('GUEST') ?>>
    <input required list=guestlist  <? draw_value('GUESTNAME');  ?>
	       onchange="on_guest_change(this)"
		   onfocus="load_userlist(guestlist, 'guest')"
    ><span id=reqshowguest class=ToolBtn title='  ' onclick='guest_click()' <? if(!$REQUISITION) echo 'hidden' ?>>
	 <img src='img/0.png'></span
	 ><span id=reqnewguest class=ToolBtn title='  ' onclick='guest_click()' <? if($REQUISITION) echo 'hidden' ?>
	 ><img src='img/navnew.png'></span>

<style>
#reqshowguest[hidden],
#reqnewguest[hidden] {display: none;}
</style>		   
		   
    <datalist id=guestlist><option value=''></datalist>		   

	
<script>
function guest_show_data(num)
{  reqform.GUEST.value=num;
   reqshowguest.hidden=false;
   reqnewguest.hidden=true;
   reqform.GUEST.classList.add('hasguest');
   reqphoto.src="photo.php?num="+num+'&v='+Math.random();       
   var fd=new FormData;
   fd.set('guest', num);
   var xhr = new XMLHttpRequest;
   xhr.open('POST', 'filt_users.php?type=orgname', false);
   xhr.send(fd);
   reqform.GUESTORG.value=xhr.responseText;	 
}

function on_guest_change(inp)
{
 if(inp.value)
  if(op=find_userlist_option(guestlist, inp.value))
   { guest_show_data(op.dataset.num);
     return;
   }
 reqphoto.src='';
 reqform.GUEST.value='';
 reqform.GUESTORG.value=''
 reqshowguest.hidden=true;
 reqnewguest.hidden=false;
}

function load_userlist(list, type)
{ if(list.dataset.loaded) return;
  var xhr = new XMLHttpRequest;
  xhr.open('POST', 'filt_users.php?type='+type, false);
  xhr.send();
  if(xhr.status==200)  
    {  list.innerHTML = xhr.responseText;   
       list.dataset.loaded=1;
	}
  else alert(xhr.responseText); 
}

function guest_click()
{ 
  if(reqform.GUEST.value)
    { table_load_form(guests, {num: reqform.GUEST.value});
	  table_set_class(guestform, ts_selected);
	}
  else
   {  table_insert_form(guests);
      guestform.USERNAME.value=reqform.GUESTNAME.value;  
   }
}


function after_guest_post(event)
{ 
  reqform.GUESTNAME.value=guestform.USERNAME.value;  
  guest_show_data(event.detail.row.dataset.num);
  delete guestlist.dataset.loaded;
  table_close_form(guests);
}
</script>
<? } ?>		   
</td>
</tr>

<tr><td> </td>
<td><input required <? draw_date_value('VISIT_DATE');  echo $readonly;  ?> 
           onchange="if(!this.form.VISIT_LAST_DATE.value) this.form.VISIT_LAST_DATE.value=this.value"></td></tr>


<tr><td></td>
<td><input required <? draw_date_value('VISIT_LAST_DATE'); echo $readonly; ?>></td></tr>


<tr><td></td>
<td>
<? 
if($readonly) 
{ $LEVELNAME = $db->query("select a_name from D_ACCESS_LEVELS where a_level=$RENCH_LEVEL")->fetchColumn();
  echo "<input readonly "; draw_value('LEVELNAME'); echo ">"; 
}
else
{
if(!isset($RENCH_LEVEL))  $RENCH_LEVEL=$REQ_DEFLEVEL;
draw_lookup('RENCH_LEVEL', $db->query("select A_LEVEL,A_NAME from D_ACCESS_LEVELS ".sql_where("where A_LEVEL",RT_LEVELS)." order by A_NAME")->fetchAll(PDO::FETCH_NUM));
} ?>
</td></tr>


<tr><td rowspan=2></td>
<td><input readonly <? draw_value('INITIATORGROUPNAME') ?>></td></tr>

<tr>
<td>
<? if($readonly)   {echo "<input readonly "; draw_value('INITIATORNAME'); echo ">"; }
   else { ?>
<input type=hidden <? draw_value('INITIATOR') ?>>
<input required <? draw_value('INITIATORNAME') ?> list=ownerlist 
       onchange="on_initiator_change(this)"	   
	   onfocus="load_userlist(ownerlist, 'owner')">	   
<datalist id=ownerlist><option value=''></datalist>

<script>
function on_initiator_change(inp)
{
 if(inp.value)
  if(op=find_userlist_option(ownerlist, inp.value))
   { inp.form.INITIATOR.value=op.dataset.num;
	 var fd=new FormData;
     fd.set('user', op.dataset.num);
     var xhr = new XMLHttpRequest;
     xhr.open('POST', 'filt_users.php?type=groupname', false);
     xhr.send(fd);
     inp.form.INITIATORGROUPNAME.value=xhr.responseText;
     return;
   }
 inp.form.INITIATOR.value='';
 inp.form.INITIATORGROUPNAME.value='';
}
</script>
<? } ?>
</td></tr>



<tr>
<td> </td>
<td><input <? draw_value('AIM'); 
              echo $readonly;
              if($GUEST_REQUIRED_AIM && !$REQUISITION) echo ' required' ?>></td>
</tr>

<? foreach($db->prepare_execute("select t.*, d.data from D_REQ_DATA_TYPES t 
                                 left join D_REQ_DATA d on t.id=d.type_id and d.req_id=:requisition 
                                 order by t.id", $_GET) as $row)
   {  
     echo "<tr>";
     echo "<td>$row[NAME]</td>";
     echo "<td><input "; 
	 draw_name_value("DATA_$row[ID]", $row['DATA']);	 
	 if(!is_null($row['REQ_TYPE'])) echo " data-rt=$row[REQ_TYPE]";
     if($row["EDIT_MASK"]) echo " pattern='$row[EDIT_MASK]'";
	 if($row["REQUIRED"])  echo " required"; 
  	 if($row["SCREEN_SIZE"]) echo " style='width: $row[SCREEN_SIZE]px'";	
	 echo $readonly;
	 echo "></td>";
	 echo "<tr>\r\n";
   }
?>					   

<tr><td style="vertical-align: top"></td>
<td><? draw_memo('NOTES', "rows=4 $readonly") ?></td></tr>

<tr class=noinsert>
<td></td>
<td><input readonly <? draw_value('EDITOR_NAME') ?>></td>
</tr>

<tr class=noinsert><td></td>
<td> <input readonly value="<? if($REQUISITION) echo (new DateTime($CREATED))->format('d.m.Y G:i'); ?>">
</td></tr>

<? if($giveform && !isset($CARD_NUM)) { ?>
<tr id=cardrow>
<td> </td>
<td>
<input type=hidden <? draw_value('REQUISITION') ?>" form=giveform>
<input name=CARD_NUM maxlength=4 form=giveform>
<button class=TButton form=giveform><img src='img/ok.png'><span></span></button>
<!-- <? if($GUEST_PERS_CODE) { ?>  <input name=PERS_CODE maxlength=4> <? } ?> -->

<script>
giveform.CARD_NUM.focus(); 
</script>
</td>
</tr>
<? } ?>

</table>


</form>
