<?php 
include "form.php"; 
include "table.php"; 
include "TNav.php"; 
?>
<link rel="icon" href="img/16.png">
<link rel="stylesheet" href="TButton.css">

<style>
#activearea, #guestsarea
  {display: inline-block;
   vertical-align: top;
   max-height: 100%
   overflow-y: auto;
   width: 55ch;
  }

td.REQUISITION,
td.CARD_NUM {text-align: right;}

col.GUESTNAME {width: 100%}  

#reqform:empty { display: none; }			   

#extractform {padding: 10px; }

#extractdialog:modal {position: absolute; left: 0; top: 0;  }
</style>


<title>    </title>

<script>
function show_req(ev)
{ var xhr = new XMLHttpRequest;
  xhr.open('GET', 'reqform.php?give&id='+ev.detail.row.dataset.requisition, false);  
  xhr.send();
  load_form(reqform, xhr);
}

function close_req()
{  reqform.innerHTML =''; }


function req_givecard(ev)
{ ev.preventDefault();
  table_action(active, 'givecard', new FormData(giveform));
  update_tables();
  close_req();
}

function update_tables()
{ table_reopen(active, active.id);
  table_reopen(guests, guests.id);
}

document.addEventListener("DOMContentLoaded", 
   function() { update_tables();                 
              }); 

</script>

</head>
<body id=workarea>

<form id=giveform hidden autocomplete=off 
      onsubmit='req_givecard(event)'></form>

<div id=reqform></div>

<div id=activearea>
<table id=active class="table grid noinplace"
       table_data='reql_data.php'
	   on_table_dblselect="show_req(event)"
       on_table_deselect="close_req()"
>
<caption class=TNav><span> </span>
<button class=TButton onclick="extractform_show()" style="float: right; visibility: hidden;"><span></span></button>
</caption>
</table>
</div>


<div id=guestsarea>
<table id=guests class="table grid noedit"
       table_data='reql_data.php'
	   on_table_dblselect="show_req(event)"
       on_table_deselect="close_req()"
>
<caption class=TNav><span> </span>
<button class=TButton onclick="extractform_show()" style="float: right"><span></span></button>
</caption>
</table>
</div>


<dialog id=extractdialog class=window>
<div class=title>    <div class=winclose title="" onclick="extractdialog.close()"></div></div>
<form id=extractform onsubmit="extractform_submit(event)" autocomplete=off>

  <input size=4 name=CARD_NUM required> <br><br>
<label>    <input type=checkbox name=HIDDEN></label><br><br>

<button class=TButton type=submit><span></span></button> 
<button class=TButton type=button onclick='extractdialog.close()'><span></span></button>
</form>
</dialog> <!-- extractdialog -->

<script>
function extractform_show()
{ extractform.reset(); 
  if(tr=table_current_row(guests))
    extractform.CARD_NUM.value=tr.dataset.card_num;
  extractdialog.showModal();
}

function extractform_submit(ev)
{
  ev.preventDefault()
  table_action(guests, 'extract', new FormData(extractform));
  extractdialog.close();
  update_tables(); 
}
</script>



</body> <!-- workarea -->
</html>  