<?php 
$REPORT=new class 
{ public $id=2;
  public $name='';
  public $description="   ";
};

if(include "repbase.php") return;


if($_SERVER['REQUEST_METHOD']==='POST')
{
 include "librep.php"; 
 
 $q=$db->prepare_execute("select e.datetime,l.reader_type from EVENTS e,D_EVENTS_TYPE t,D_TER_ZONES_LINK l
                          where e.datetime between :report_from and :report_to and e.event_type=t.id 
                                and l.reader=e.param1 and e.system_type=2 and t.e_move=1
                                and e.param2=:user and l.ter_zone+0=:report_tz order by e.datetime", $_POST);
 
 $dates=[]; //   'Y-m-d' => []																
 foreach(user_invervals($q) as $int)
   $dates[($int[0] ?? $int[1])->format('Y-m-d')][]=$int;
		
 $totals=[]; //   //null- 		
 $ref=new DateTime("00:00");
 foreach($dates as $d=>$ints)		
 {$totals[$d]=clone $ref;
  foreach($ints as $int)
   if(is_null($int[0]) || is_null($int[1]))
         { $totals[$d]=null; 
		   continue 2; }
   else	   $totals[$d]->add(date_diff($int[0], $int[1]));
  $totals[$d] = $ref->diff($totals[$d]);
 }  

   
 //
 foreach($dates as $date=>$ints)		
  foreach($ints as $idx=>$int)
  {
   echo "<tr", $idx==0 ? ' class=newdate' : '','>';
   if($idx==0) echo "<td rowspan=",count($ints),">",(new DateTime($date))->format('d.m.Y'),"</td>";
   foreach($int as $v)
     echo "<td>", $v ? $v->format('G:i:s') : '' ,"</td>";
   if($idx==0) echo "<td rowspan=",count($ints),">",$totals[$date] ? $totals[$date]->format('%h:%I:%S') : '???',"</td>";   
   echo "</tr>\r\n";   
  }
   
   
 
 $db->prepare_execute("update D_EDITOR_SETTINGS set  report_from = :report_from,  report_to = :report_to,  report_tz = :report_tz  where  editor = $editor", $_POST);
 exit();
}


//GET
extract($db->query("select REPORT_FROM,  REPORT_TO,  REPORT_TZ from D_EDITOR_SETTINGS  where EDITOR=$editor")->fetch(PDO::FETCH_ASSOC));

if($config_ini['DemoMode'] ?? 0)
{ $REPORT_FROM = '2018-03-01';
  $REPORT_TO =   '2018-04-01';
}

include "form.php"; 
include 'formdraw.php';
include 'filt_users.php';
include "excel.php"; 
?>
<link rel="icon" href="img/28.png">
<link rel="stylesheet" href="TButton.css">


<style>
#workarea {white-space: nowrap; }

#workarea > * {display: inline-block;
               vertical-align: top; 
               max-height: 100%;
			   overflow-y: auto;
			  }
#username { min-width: 30ch;}
		 

.report th {position: static;}
.report td {text-align: center;}
.report caption {position: sticky;
                 top: 0;
				 text-align: left; }
</style>

<style media=excel id=rstyle>
 td {text-align: center;}
</style>



<style media=screen>
tr.newdate>td {border-top-width: 2px;}
</style>

<style media=print>
#params {display: none; }
</style>


<title> </title>

</head>
<body id=workarea>

<form id=params class="window fix-height" autocomplete=off>
<div class=title>  </div>
<table>
<tr><td></td>
<td><?php
draw_lookup('REPORT_TZ', $db->query('select NUM,ZONENAME from TER_ZONES '.sql_where("where NUM",RT_TZ).' order by ZONENAME')->fetchAll(PDO::FETCH_NUM));
?></td></tr>

<tr><td> </td>
<td>
<script>
function from_change(inp)
{
 if(inp.value)
 { let d=inp.valueAsDate; 
   d.setDate(d.getDate() + 1);
   inp.form.REPORT_TO.valueAsDate=d;
 }
}
</script>
<input <? draw_date_value('REPORT_FROM') ?> required onchange='from_change(this)'></td></tr>
<tr><td> </td>
<td><input <? draw_date_value('REPORT_TO') ?> required></td></tr>

<tr><td></td>
<td>
<select name=type onchange="load_userlist()">
  <option value=owner selected></option>
  <option value=deleted></option>
  <option value=guest></option>
</select>
</td></tr>


<tr><td></td>
<td>
<select id=usergroup name=group onchange='load_userlist()'>
<option value=''></option>
<?php
foreach($db->query('select NUM,GROUPNAME from GROUPS '.sql_where("where num",RT_GROUPS).' order by GROUPNAME') as $row)
 echo "<option value='$row[0]'>$row[1]</option>";
?>
</select>
</td></tr>

<tr><td></td>
<td style="white-space: nowrap">
<input type=hidden name=user>
<input type=text id=username required placeholder=' ' list=userlist spellcheck=false
><button type=button onclick="username.value=''" title='  ' style="padding: 1px 3px">x</button> 

<style>
#username:placeholder-shown+button {visibility: hidden;}
</style>

<datalist id=userlist>
<? draw_userlist('owner'); ?>
</datalist>
</td></tr>


<tr><td></td>
<td><button type=button class=TButton onclick="on_report()"><img src="img/28.png"><span>C</span></button>
    <button id=btnprint hidden type=button class=TButton onclick="window.print()"><img src="img/38.png"><span></span></button>
	<a onclick="on_excel(this,event)">
    <button type=button id=btnexcel class=TButton hidden><img src="img/excel.png"><span>Excel</span></button></a>
</td>
</tr>

</table>

<script>
function load_userlist()
{ username.value='';
  var xhr = new XMLHttpRequest;
  xhr.open('POST', 'filt_users.php', false);
  xhr.send(new FormData(params));
  if(xhr.status==200)  
       userlist.innerHTML = xhr.responseText;   
  else alert(xhr.responseText); 
}

function on_report()
{
 params.user.value=find_userlist(userlist, username.value);
 username.setCustomValidity(!params.user.value ? '  ' : ''); 
 if(!params.reportValidity()) return;
   
 var xhr = new XMLHttpRequest;
 xhr.open('POST', location.pathname, false);
 xhr.send(new FormData(params));
 if(xhr.status!=200) alert(xhr.responseText); 
 else
 params.insertAdjacentHTML('afterend',
`
<table class='grid report'>
<caption class=title>${username.value}<div class=winclose onclick="this.closest('.report').remove()" title=" "></div></caption>
<thead><th></th><th></th><th></th><th></th></thead>
<tbody>${xhr.responseText}</tbody>
</table>`);

 btnprint.hidden=btnexcel.hidden=false;
}


function on_excel(a, event)
{ 
  if(rp=document.getElementsByClassName('report')[0])
  { let name=rp.querySelector(':scope .title').innerText; 
    a.href=excel_table(rp,rstyle,name);
    a.download=name+'.xls';
  }	
  else event.preventDefault();
}
</script>


</form> <!-- params -->


</body> <!-- workarea -->
</html>  