<?php 
$REPORT=new class 
{ public $id=3;
  public $name='  ';
  public $description=" ";
};
if(include "repbase.php") return;
include 'colors.php';

const MaskShowColor = 1<<0;
const MaskShowGroup = 1<<1;
const MaskShowReader =1<<2;
const MaskShowTime   =1<<3;
const MaskShowRel    =1<<4;
const MaskShowN      =1<<10;
const MaskRadioOut   = 1<<5;

const MaskSort = 0x7<<7;
const MaskSortByTime =   0<<7;
const MaskSortByGroup =  1<<7;
const MaskSortByColor =  2<<7;
const MaskSortByName =   3<<7;
const MaskSortByReader = 4<<7;
  


if(isset($_POST['start'])) //$_SERVER['REQUEST_METHOD']==='POST' &&
{
 $WHERE_OPT =   intval($_POST['WHERE_STATE']) 
              | intval($_POST['WHERE_SORT']);
 
 foreach(array_keys($_POST['OPT'] ?? []) as $mask)
  $WHERE_OPT |= intval($mask);
 
 $db->prepare_execute("update D_EDITOR_SETTINGS set WHERE_TZ=:WHERE_TZ, WHERE_GR=:WHERE_GR, WHERE_FREQ=:WHERE_FREQ, WHERE_OPT=$WHERE_OPT where editor= $editor", $_POST);
}


if(isset($_POST['update']))
    { parse_str($_POST['update'], $update_data);
	  foreach($update_data as $name=>$value)
	    $$name=intval($value);
	  $WHERE_GR = $WHERE_GR ?? null;	
	}
else extract($db->query("select WHERE_TZ,WHERE_GR,coalesce(WHERE_FREQ,10) as WHERE_FREQ,coalesce(WHERE_OPT,0) as WHERE_OPT from D_EDITOR_SETTINGS where editor=$editor")->fetch(PDO::FETCH_ASSOC));


$WHERE_SORT =  $WHERE_OPT & MaskSort;
$WHERE_STATE = $WHERE_OPT & MaskRadioOut;
$gfilter= $WHERE_GR ? "and u.usergroup=$WHERE_GR" : '';

if(isset($_POST['start']))
{
 $report_id=$db->query('select gen_id(d_gen_session_id,1) from rdb$database')->fetchColumn();
 //clear garbage 
 $db->exec("delete from D_WHERE_TEMPORAL where (datetime is null and session_id+10<$report_id) or datetime+3<'now'");
  
 $states=[];

 $q=$db->query("select e.param2 as usernum,e.datetime,e.param1 as reader,l.reader_type from EVENTS e,D_EVENTS_TYPE t,D_TER_ZONES_LINK l,USERS u
                where e.datetime>cast('now' as date)-2 and e.event_type=t.id and e.param1=l.reader and l.ter_zone+0=$WHERE_TZ  and e.system_type=2 and t.e_move=1  and u.num=e.param2  $gfilter   
                order by datetime desc");
 while($row=$q->fetch(PDO::FETCH_ASSOC))
  if(!isset($states[$row['USERNUM']]))
    $states[$row['USERNUM']] = $row; 

  if($WHERE_STATE)
   foreach($db->query("select u.num as usernum, null as datetime, -1 as reader_type, null as reader from USERS u, D_OWNERS o where u.num=o.user_ref $gfilter") as $row)
     if(!isset($states[$row['USERNUM']]))
   	  $states[$row['USERNUM']] = $row; 

  $q=$db->prepare("insert into  D_WHERE_TEMPORAL (session_id,usernum,datetime,state,reader) values ($report_id,:USERNUM,:DATETIME,:READER_TYPE,:READER)");
  foreach($states as $num=>$row)
    $q->execute($row);
}


if(isset($_POST['update']))
{
  $need_update = $WHERE_OPT & MaskShowRel;
  
  foreach($db->query("select e.datetime,e.param2 as usernum,l.reader,l.reader_type from EVENTS e,D_EVENTS_TYPE t,D_TER_ZONES_LINK l, USERS u
                      where e.num>$last_num and e.event_type=t.id and l.reader=e.param1 and l.ter_zone=$WHERE_TZ 
                      and e.system_type=2 and t.e_hardware=1 and t.e_move=1 $gfilter") as $row)
  {					  
   if($db->query("select * from D_WHERE_TEMPORAL where session_id=$report_id and usernum=$row[USERNUM]")->fetch()) 					  
        $q=$db->prepare_execute("update D_WHERE_TEMPORAL set datetime=:DATETIME, state=:READER_TYPE, reader=:READER
		                         where session_id=$report_id and usernum=:USERNUM and datetime<:DATETIME",$row);
   else $q=$db->prepare_execute("insert into D_WHERE_TEMPORAL (session_id,usernum,datetime,state,reader) values ($report_id,:USERNUM,:DATETIME,:READER_TYPE,:READER)",$row); 
   
   if($q->rowCount()) $need_update = true;
  }   
}

if(isset($_POST['update']) || isset($_POST['start']))
{
 $last_num =$db->query('select max(num) from EVENTS')->fetchColumn();

 $update_data = http_build_query(compact('WHERE_OPT', 'WHERE_TZ', 'WHERE_GR',  'report_id', 'last_num'));

 if(isset($_POST['update']) && !$need_update)
    exit($update_data);
 //full update 
 $fields=[];
 if($WHERE_OPT & MaskShowN)      $fields['N']        ='';   
 if($WHERE_OPT & MaskShowTime)   $fields['DATETIME'] ='';  
 if($WHERE_OPT & MaskShowRel)    $fields['DIFF']     ='';  
 if($WHERE_OPT & MaskShowReader) $fields['READ_NAME']=''; 
  
                                 $fields['USERNAME'] ='';
 if($WHERE_OPT & MaskShowColor)  $fields['COLOR']    ='';
 if($WHERE_OPT & MaskShowGroup)  $fields['GROUPNAME']='';
 
 echo "<thead data-update='$update_data'>","<tr>"; 
 foreach($fields as $name=>$title)
   echo "<th class=$name>$title</th>";
 echo "</tr></thead>";  
 
  
 
 echo "<tbody>"; 
 
 $sort = [MaskSortByTime  => 't.datetime desc',
          MaskSortByGroup => 'g.groupname, u.username',
          MaskSortByColor => 'o.color, u.username',
          MaskSortByName  => 'u.username',
          MaskSortByReader => 'r.read_name, u.username'] [$WHERE_SORT];
 $N=0;
 $now = new DateTime($db->query('select cast("now" as date) from rdb$database')->fetchColumn());
 foreach($db->query(
  "select t.datetime, null as diff, u.username, o.color, g.groupname, r.read_name from D_WHERE_TEMPORAL t 
   join USERS u on t.usernum=u.num
   join D_OWNERS o on o.user_ref=u.num
   left join D_ABSTRACT_READERS r on t.reader=r.reader
   left join GROUPS g on u.usergroup=g.num 
   where t.session_id=$report_id and t.state=".($WHERE_STATE ? -1 : 1)." order by $sort") as $row)
 {
  $attrs=[];
  $row['N']=++$N;
  if(!is_null($row['DATETIME'])) 
  {
    $dt=new DateTime($row['DATETIME']);
    $row['DATETIME']=$dt->format('G:i:s');
    $diff =  date_diff($dt, $now);
    $row['DIFF']=$diff->days ? '>' : $diff->format('%h:%I:%S');
  }	
  if(is_null($row['COLOR'])) 
         $row['COLOR']='';  
  else 	{$attrs['COLOR']=color_background_style($row['COLOR']);
         $row['COLOR']='';
        }  
  
  
  echo "<tr>"; 
  foreach(array_keys($fields) as $name)
   echo "<td class=$name",$attrs[$name] ?? '',">",$row[$name],"</td>";
  echo "</tr>";   
 }  
 echo "</tbody>"; 
 exit("<tfoot><tr><td colspan=".count($fields).">: $N</td></tr></tfoot>"); 
}   
   

//GET
include "form.php"; 
include 'formdraw.php';
?>
<link rel="icon" href="img/28.png">
<link rel="stylesheet" href="TButton.css">

<style>
#workarea > * {vertical-align: top;}
#params { display: inline-block; }
#params fieldset {padding: 5px;}
#params button {margin: 5px;}
#report td {text-align: center;}
#report td.USERNAME {text-align: left;
                     min-width: 30ch; }
#report th.COLOR {padding: 0;}
#report tfoot td {text-align: right;
                  font-weight: bold;
				  font-size: larger;  }		 

#report:empty {display: none; }

#report_area { display: inline-block;
               max-height: 100%;
			   overflow-y: auto;  }
</style>


<title><? echo $REPORT->name ?></title>

</head>
<body id=workarea>




<form id=params class=window method=post>
<div class=title>  </div>
<table>
<tr><td></td>
<td><? draw_lookup('WHERE_TZ', $db->query('select NUM,ZONENAME from TER_ZONES '.sql_where("where NUM",RT_TZ).' order by ZONENAME')->fetchAll(PDO::FETCH_NUM)); ?>
</td></tr>

<tr><td></td>
<td> <? draw_lookup('WHERE_GR', [ -1 => [null, '']] + $db->query('select NUM,GROUPNAME from GROUPS '.sql_where("where num",RT_GROUPS).' order by GROUPNAME')->fetchAll(PDO::FETCH_NUM)); ?>
</td></tr>

<tr><td></td>
<td><? draw_select('WHERE_STATE', [ 0 =>            '',
                                    MaskRadioOut => '' ]); ?>
</td></tr>

<tr><td></td>
<td><? draw_select('WHERE_SORT',[ MaskSortByTime => '  ',
                                  MaskSortByGroup => ' ',
                                  MaskSortByColor => ' ',
                                  MaskSortByName => ' ',
                                  MaskSortByReader => ' ' ]);  ?> 								  
</td></tr>

<tr><td> </td>
<td><input type=number <? draw_value('WHERE_FREQ') ?> required min=1 max=999> .
</td></tr>
</table>

<fieldset>
<legend> </legend>
<?
foreach([MaskShowColor => ' ',
         MaskShowGroup => ' ',
         MaskShowReader => ' ',
         MaskShowTime   => ' ',
         MaskShowRel    => ' ',
         MaskShowN      => ' '] as $mask=>$name)
 echo "<label><input type=checkbox name='OPT[$mask]'",$WHERE_OPT & $mask ? ' checked' : '',">$name</label><br>";
?>
</fieldset>

<center><button type=button class=TButton onclick="on_start()"><img src="img/28.png"><span>C</span></button></center>
</form> <!-- params -->

<div id=report_area>
<table id=report class=grid></table>
</div>

<script>
function on_start()
{ if(!params.reportValidity()) return;
  var fd=new FormData(params);
  fd.set('start',1);
  var xhr = new XMLHttpRequest;
  xhr.open('POST', '', false);
  xhr.send(fd);
  if(xhr.status==200)  
     { report.innerHTML = xhr.responseText;   
	   setInterval(on_update, Number(params.WHERE_FREQ.value) * 1000);
	   params.remove();
	 }
  else alert(xhr.responseText); 
}

function on_update()
{ 
  var fd=new FormData;
  fd.set('update',report.tHead.dataset.update);
  var xhr = new XMLHttpRequest;
  xhr.open('POST', '', false);
  xhr.send(fd);
  if(xhr.status!=200) alert(xhr.responseText); 
  else
  if(xhr.responseText.startsWith('<')) //thead tag
     report.innerHTML = xhr.responseText;   	 
  else
     report.tHead.dataset.update=xhr.responseText;  
}
</script>




</body> <!-- workarea -->
</html>  