<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_TIMEZONES);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name = 'SMENA'; 
 	  public $data= true;
	  public $visible=false;
      public $generator='D_GEN_SMENA';
    },
    new class extends StringField
    { public $name = 'NAME';
      public $caption = ' ';  
  	  public $size=64;	  
    }
  ];   
  	

  $this->select_sql ='select * from D_SMENA order by name';   
  $this->refresh_sql='select * from D_SMENA where smena=:smena';
  $this->delete_sql ='delete from D_SMENA where smena=:smena';
  $this->update_sql ='update D_SMENA set name = :name where smena = :smena';
  $this->insert_sql ='insert into D_SMENA (smena, name) values (:smena, :name)'; 
 }
 
 
 }; //TDataset