<?php
include_once("system.php"); 
include_once("login.php"); 
include_once("colors.php");

$db->autocommit=false;

$params = [];

if($_SERVER['REQUEST_METHOD']==='POST') //load period
{ $params=$_POST;
  $params['@filter']=' and e.datetime>=:start_date';
  if(!empty($params['end_date']))
    $params['@filter'].=' and e.datetime<:end_date';
}
else //check new
{ $params['last_num']= $db->query("select last_notify_event_num from D_EDITOR_SETTINGS where editor=$editor")->fetchColumn() ?: 0;
  $params['@filter']= ' and e.num>:last_num';
  $db->exec("update D_EDITOR_SETTINGS set last_notify_event_num=(select max(num) from events) where editor=$editor");
}

foreach($db->prepare_execute("
 select e.num, e.datetime,
        (select msg from D_EVENT_MSG(e.event_type,e.param1,e.param2,e.param3,e.param4,e.param5)) as msg,
        (select color from d_events_type where id=e.event_type) as color
	   
 from EVENTS e,D_NOTIFY_TYPES n 
 where e.system_type=2 and e.event_type=n.id+0 and n.editor=$editor 
       and (n.restrict_doors=0 or exists (select * from D_NOTIFY_DOORS where editor=$editor and id=e.event_type and reader=e.param1))
	   @filter
 order by e.datetime,e.num", $params) as $r)
{
 $dt = new DateTime($r[1]); 				 
 echo "<tr data-num=$r[0]>",
      "<td>", $dt->format('G:i:s'), "</td>", 
      "<td>", $dt->format('d.m.y'), "</td>",
	  "<td",color_background_style($r[3]),">$r[2]</td>";
 echo "</tr>\r\n";	  
}

$db->autocommit=true;
