<?php
include_once "elacset.php"; 
include_once "WF3.php"; 
include_once 'cardcode.php';

assert_right(RT_FUNCTIONS, RI_HARDWARE);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends DBLookupField
    { public $name = 'READER'; 
      public $caption = '';  
 	  public $data= true;
	  public $query='select reader,read_name from D_DEVICES order by read_name';
    },
    new class extends DBLookupField
    { public $name = 'USERGROUP'; 
      public $caption = '';  
 	  public $data= true;
	  public $query='select num,groupname from GROUPS order by groupname';
    }
  ];   

  
  $sel = 'select h.reader,h.usergroup, d.read_name, g.groupname from D_CARD_HOLDER h,D_DEVICES d, GROUPS g where h.reader=d.reader and h.usergroup=g.num';
		  
  $this->select_sql = $sel.' order by d.read_name';     
  $this->refresh_sql= $sel.' and reader=:reader and usergroup=:usergroup';
  $this->delete_sql = 'delete from D_CARD_HOLDER where reader=:reader and usergroup=:usergroup';
  $this->insert_sql = 'insert into D_CARD_HOLDER (reader,usergroup) values (:reader,:usergroup)'; 
 }
 

 
protected $error_map = ['D_CARD_HOLDER_PK' => '   '];  
  
 
 }; //TDataset 