<?php 
include("form.php"); 
include_once("servmod.php");
include("vendor.php"); 
include("dev_ip.php"); 
?>

<link rel="icon" href="img/27.png">
<link rel="stylesheet" href="TButton.css">

<style>

<? gen_RI_style(['RI_HARDWARE', 'RI_OPEN_DOOR', 'RI_EVENTSBASE']); ?>


#workarea   {display: flex;
             align-items: start; }

#diagarea
      { max-height: 100%;
		width:  50ch;
		margin-right: 3px;
        overflow-y: auto; 
        user-select: none;				
      } 

#dataarea
      {	display: flex;
        flex-direction: column;
  	    max-height: 100%;
		position: relative;
      } 
	  
 #dataarea:empty { display: none; }

 #dataarea > .title
      { flex: none; 
	    padding-right: 20px;
	  }   
	  

 .unexecuted  {background-color: var(--GlobalYellow); text-align: center;}
 .status_ok   {background-color: var(--GlobalGreen);}
 .status_fail {background-color: black; color: white;}
 .status_unk  {background-color: transparent;}
 .status_err,
 .status_cnt  {background-color: var(--GlobalRed); }


  #diagtree	li { position: relative;  }	
  
  #diagtree li>span:hover
         { text-decoration: underline;
           color: #0066CC;
          }
  
  .status, 
  .queue   {text-align: center; 	
            font-family: serif;
            position: absolute;
            height: 20px;
			width: 40px;
			top: 0;
          }
		  
  .status {	right: 0px;}
  .queue  { right: 40px;}	   
  
  .schit>span {cursor: pointer;} 
</style>


<title></title>
</head>
<body id=workarea>
<? include "diag_menu.php";  ?>

<div class=window id=diagarea>
<div class=title><img src='img/27.png'>  <? echo PRODUCT_NAME ?></div>
<ul class=menutree id=diagtree>
<?php 

$level=0;
function set_level($l) 
{ global $level;
  for(;$level>$l; $level--) echo "</ul>\r\n", "</li>\r\n";
}

$q=$db->query('select d.computer, c.name as comp_name, d.adr,d.schit,d.read_name,d.reader_type,d.reader, c.inetaddr, d5.program 
               from D_DEVICES d 
			   join COMPUTERS c on c.computer=d.computer 
			   left join D5_DEVICES d5 on d5.adr=d.adr and d5.computer=d.computer
			   order by d.computer,iif(d.adr<0, -d.adr, d.adr),d.schit');

$prev=null;
while($r=$q->fetch()) 
{
 //skip deleted dev
 if($r['READER_TYPE']==-1)
 {$rskip=$r;
  do {$r=$q->fetch();} 
  while($r && $rskip['COMPUTER']==$r['COMPUTER'] && $rskip['ADR']==$r['ADR']);    
  if(!$r) break;
 }

 $newl=!$prev;

 if($newl || $prev['COMPUTER']!=$r['COMPUTER'])
 { $newl=true; 
   set_level(0);
   $id="checkcomputer".$r['COMPUTER'];
   echo  "<li class=computer data-computer=$r[COMPUTER] data-ip='$r[INETADDR]' data-name='$r[COMP_NAME]' data-wsocket=true>
          <input type=checkbox id=$id checked>
		  <label for=$id><img src='img/d0.png'>$r[COMP_NAME]</label>  
          <div class=queue id='compqueue$r[COMPUTER]' data-computer=$r[COMPUTER] data-addr='-1'></div>
          <div class=status id='compstatus$r[COMPUTER]'></div>
          <ul>\r\n";
   $level++;		  
 }  

 $ip=is_dev_ip_addr($r['ADR']);
 $r['vetv']=$ip ? -1 : dev_addr_to_vetv($r['ADR']);
   
 if($newl || $prev['vetv']!=$r['vetv'])
 { $newl=true;
   set_level(1);
   $id="checkvetv".$r['COMPUTER'].'-'.$r['vetv'];
   if($ip)  { $img=14; $name='Ethernet';}
      else  { $img=1;  $name=' '.$r['vetv'];}
   
   echo  "<li>
          <input type=checkbox id='$id' checked>
		  <label for='$id'><img src='img/d$img.png'>$name</label>  
          <ul>\r\n";
   $level++;		  
 }  
 
 if($newl || $r['ADR']!=$prev['ADR'])
 { 
   set_level(2);
   $id="checkdev".$r['COMPUTER'].'-'.$r['ADR'];
   echo  "<li class=device data-computer=$r[COMPUTER] data-addr='$r[ADR]' data-type=$r[READER_TYPE] data-reader=$r[READER]", 
              $ip ? ' data-ip="'.dev_addr_str($r['ADR']).'"' : '',
			  $r['READER_TYPE']>=3 ? ' data-el05' : '',
			  $r['PROGRAM'] ? ' data-vm' : '',
		  ">
          <input type=checkbox id='$id'", ($config_ini['DemoMode'] ?? 0) ? ' checked' : '',">
		  <label for='$id'><img src='img/d2.png'>$r[READ_NAME]</label>  
          <div class=queue id='devqueue$r[COMPUTER]-$r[ADR]' data-computer=$r[COMPUTER] data-addr='$r[ADR]'></div>
          <div class=status id='devstatus$r[COMPUTER]-$r[ADR]'></div>
          <ul>\r\n";
   $level++;		  
 } 
 
 echo  "<li class=schit data-computer=$r[COMPUTER] data-addr='$r[ADR]' data-schit=$r[SCHIT] data-reader=$r[READER]>
        <span><img src='img/d3.png'>$r[READ_NAME]</span>
		</li>\r\n";	  
	
 $prev=$r;
}
set_level(0);	

$q=$db->query('select c.COMPUTER,c.NAME as comp_name,c.INETADDR from computers c 
               left join d_devices d on c.computer=d.computer 
               where d.reader is null');
while($r=$q->fetch()) 
 echo  "<li class=computer data-computer=$r[COMPUTER] data-addr='$r[INETADDR]' data-name='$r[COMP_NAME]'>
        <span><img src='img/d0.png'>$r[COMP_NAME]</span></li>\r\n";	  

 ?>
</ul>
</div> <!-- diag -->

<div id=dataarea class=window></div>


<script>
//---------------------------------------------------------------------------
function draw_status(n, status)
{
 if(n.dataset.status && n.dataset.status==status) return;
 n.dataset.status=status;

 while(n.classList.length>1)
   n.classList.remove(n.classList[n.classList.length-1]);
   
 if(status=="OK")   n.classList.add("status_ok");    else
 if(status=="FAIL") n.classList.add("status_fail");  else 
 if(status=="ERR")  n.classList.add("status_err");   else
 if(status=="?")    n.classList.add("status_unk");   else   
 if(typeof status=="number") n.classList.add("status_cnt");   
 n.innerHTML=status;
}

//---------------------------------------------------------------------------
function on_diag_message(event) 
{ const comp="devstatus"+this.computer+"-";
  JSON.parse(event.data).
    forEach(v => draw_status(document.getElementById(comp+v.addr), v.status));
};
//---------------------------------------------------------------------------
function on_diag_close() 
{
  const computer=this.computer;
  draw_status(document.getElementById("compstatus"+computer), "ERR");
  
  document.querySelectorAll('#diagtree .device').forEach( function(n) 
 { if(n.dataset.computer==computer) 
     draw_status(n.querySelector(":scope > .status"), '?');   
 });     
}
//---------------------------------------------------------------------------
function on_diag_open() 
{ draw_status(document.getElementById("compstatus"+this.computer), "");}

//---------------------------------------------------------------------------
function create_socket(n) 
{
<? if($config_ini['DemoMode'] ?? 0) echo 'return;' ?>
  let ws=new WebSocket(phmodule_ws(n.dataset.ip, "diag"));
  ws.computer=n.dataset.computer;
  ws.onmessage=on_diag_message;
  ws.onopen=on_diag_open;
  ws.onclose=on_diag_close;
  n.wsocket = ws;
}

//---------------------------------------------------------------------------
function on_update_queue()
{ 
  let data=JSON.parse(this.responseText);
  document.querySelectorAll('#diagtree .queue').forEach( function(n) 
  {
    let idx=data.findIndex(function(v){ return v.COMPUTER==n.dataset.computer && v.ADDR==n.dataset.addr	})       
	if(idx==-1)
	{ n.classList.remove('unexecuted');	
 	  n.innerHTML='';
	}
	else
	{ n.classList.add('unexecuted');	
	  if(n.innerHTML!=data[idx].CNT)
        n.innerHTML=data[idx].CNT;	 
	  data.splice(idx, 1);
	} 
  })
}
//---------------------------------------------------------------------------

function update_queue()
{
  var xhr = new XMLHttpRequest();
  xhr.onload  = on_update_queue;
  xhr.open('GET', 'diag_queue.php');
  xhr.send();        
}

//---------------------------------------------------------------------------
function on_update_timer()
{
 for(let n of document.querySelectorAll('#diagtree .computer'))
   if(n.wsocket && n.wsocket.readyState==3)
     create_socket(n);
 
 update_queue();
}

//---------------------------------------------------------------------------

document.addEventListener("DOMContentLoaded", function()  
{  
<? if($config_ini['DemoMode'] ?? 0) { ?>

   for(let n of document.querySelectorAll('.device > .status'))
        draw_status(n, 'OK'); 

<? } else { ?>
   for(let n of document.querySelectorAll('.device > .status'))
        draw_status(n, '?'); 
 
   for(let n of document.querySelectorAll('.computer'))
        if(n.dataset.wsocket) 
		   create_socket(n); 
<? } ?>   
   setInterval(on_update_timer, 10000); 
   update_queue();
});
//---------------------------------------------------------------------------

</script> 

</body> <!-- workarea -->
</html>  