<?php 
include "form.php";
include "events_font.php";
include_once("servmod.php");
include "excel.php";


if($fid = intval($_GET['filter'] ?? 0))
{  
   $row=$db->query("select name,data from D_FILTERS where id=$fid and (editor=$editor".sql_where(" OR id",RT_EVENT_FILTERS).")")->fetch();
   parse_str($row['DATA'], $_GET);
   $title = $row['NAME'];
}
else assert_right(RT_FUNCTIONS, RI_EVENTSBASE);

//if(isset($_GET['newwin'])) $_GET['nomenu'] = '';

$load_params=[];
foreach($_GET as $key=>$value)
 if($value!='' && !in_array($key, ['num','date','time','live', 'all', 'nomenu', 'newwin', 'iframe'])) // 
  $load_params[$key]=$value;
   

$live = !$_GET || isset($_GET['live']); //default live mode
if($config_ini['DemoMode'] ?? 0) $live=false;

if($live) $pos = 'last';
else
if(!empty($_GET['time']) || !empty($_GET['num'])) 
     $pos = 'center';
else $pos = isset($_GET['all']) ? 'first' : 'last';
 ?>
 
<script>var load_query='<? echo http_build_query($load_params) ?>';</script>
 
 
<link rel="icon" href="img/15.png">
  
<link rel="stylesheet" href="TButton.css">
  
<style media=excel id=excel_style>  
 td { white-space: nowrap; }
 .msg {width: 500px;}
</style> 
  
<style>
 #workarea
 { display: flex;
   flex-direction: row;
   justify-content: flex-start;
   align-items: stretch;    
 }

 #events_area	
  { width: 800px; 
<?  if($div_menu) echo 'padding-bottom: 5px;' ?>
	overflow: auto;
  }	  


 #data_area	
 { max-width: 350px; }
 
<? if(isset($_GET['live'])) echo '#events_table>thead {display: none;}' ?>	
			  
 #events_table {background-color: white;} 
 
 #events_table tr.marked td:first-child, 
 #events_table tr.marked td:first-child + td   {background-color: Aqua;}

 #events_table td:first-child, 
 #events_table td:first-child + td {text-align: center;} 
 #events_table tr.selected td:nth-child(3)   {background-color: inherit; }              
 
 #events_table   { width: 100%; }    
 #events_table col.msg  { width: 100%;   }
 #events_table th.msg   { text-align: left;
                          min-width: 200px;   
                        }
 
 
<?
$exfields=[];
foreach($_GET as $key=>$value) //    . 
 if(str_starts_with($key, 'show_'))
 { $fn= explode('_', $key)[1];
   $style='';
   if($fn=='tab')   {  $exfields[]='<th>.&nbsp;</th>'; 
                       $style='text-align: right';
                    }  else
   if($fn=='group') {  $exfields[]='<th></th>';  
                       $style='white-space: nowrap'; 
                    } else
   if(is_numeric($fn)) $exfields[]='<th>'.$db->query("select PROP_NAME from user_prop_types where id=$fn")->fetchColumn().'</th>';      
   
   if($style) echo '#events_table td:nth-child(',3+count($exfields),") { $style }\r\n";
 }
 
if($exfields || $font_data) {?> 
 #events_area, #events_table, 
 #events_table col.msg { width: auto;  }				   
<?} 

if($exfields && !$font_data) {?> 
 #events_table tr>:nth-child(3) {max-width: 550px;} 
<? } ?> 
 
#events_body, #font_test
{  /* custom font settings */
<? foreach($font_data as $key=>$value)  
    if($value) 
    {  if($key=='font-size') $value.='px';
       echo "$key: $value;\r\n"; 
	}
?>
}
</style>


<style media=print>
 #nav { display: none; }  
 #data_area { display: none; }  
 #workarea  { display: block;}
 #events_table col.msg  { width: auto; }
 #events_table { width: auto; }
</style>


<script>
function do_scroll_load(mode, tr0) //return template element or null
{ if(!tr0 || tr0.dataset.eof) return;
  var xhr = new XMLHttpRequest();
  
  var sp=new URLSearchParams(load_query);
  sp.set('mode', mode);
  sp.set('count', 30);
  sp.set('num', tr0.dataset.num);  
  xhr.open('POST', 'events_load.php', false);
  xhr.send(sp);
  if(xhr.status!=200) { alert(xhr.responseText); 
                        return null;
                      } 
  if(xhr.responseText)
  {
     var templ = document.createElement("template");
     templ.innerHTML = xhr.responseText;   
     return templ;
  }
  else 
  { tr0.dataset.eof=true; 
    return null;
  }
}

function on_events_scroll_top()
{ if(events_area.scrollTop!=0) return;  
  var tr0=events_body.firstElementChild;
  var t=do_scroll_load('prev', tr0);
  if(t)
  {  events_body.insertBefore(t.content, tr0);
	 tr0.scrollIntoView();		
  }
}

function is_bottom()
{ return events_area.scrollHeight - events_area.scrollTop - events_area.clientHeight<=5}

function on_events_scroll_bottom()
{ if(is_bottom())
  { var t=do_scroll_load('next', events_body.lastElementChild);
    if(t) events_body.appendChild(t.content); 
  }	
}

function clear_selected()
{ events_body.querySelectorAll(':scope .selected').forEach( function(n) { n.classList.remove('selected'); } );  
  data_area.innerHTML=''; 
}

function body_click(ev)  //show clicked event in the data area
{let tr=ev.target.closest('tr'); 
 if(tr.classList.contains('selected'))
   clear_selected();
 else
 { clear_selected();
   tr.classList.add('selected');
   tr.classList.remove('marked');
   
   var xhr = new XMLHttpRequest();
   xhr.open('GET', 'event_detail.php?num='+tr.dataset.num, false);
   xhr.send();
   data_area.innerHTML=xhr.responseText;
 }   
}

document.addEventListener("DOMContentLoaded", function()  { events_area.focus(); })
</script>


<title><? echo $title ?? ($_GET ? ' ' : ' ') ?></title>
</head>

<body>
<?php
//
if($live) { ?> 
<script>
var last_num =<? echo $db->query('select max(num) from events')->fetchColumn() ?? 0 ?>;
const marked_time=4000;

var xhr = new XMLHttpRequest();
xhr.onerror = function()   { data_area.innerHTML ="   "; }
xhr.onload  = function()
{ 
   const bottom = is_bottom(); 
 
   if (this.status!=200)  data_area.innerHTML = this.responseText;   
   else
   if(this.responseText)
   { var templ = document.createElement("template");
     templ.innerHTML = this.responseText;   
     var list=templ.content.children;
     while(list.length)
     { let tr=list[0];
       tr.classList.add('marked');  
       if(last_num<tr.dataset.num) last_num=Number(tr.dataset.num);	  
	  
	   let p=events_body.lastElementChild; //insert after p
	   for(; p; p=p.previousElementSibling)
	     if(p.dataset.datetime<tr.dataset.datetime)
	       break;
	  
	   events_body.insertBefore(tr, p ? p.nextElementSibling : events_body.firstElementChild);  
	  
	   if(bottom) setTimeout(function(){ tr.classList.remove('marked'); }, marked_time); 	   
     }  
     if(bottom && !events_body.querySelector(':scope .selected')) 
   	      events_area.scrollTo( { top: events_area.scrollHeight, behavior: "smooth" } );
	 else btn_last.style.display = "inline-block"; 
   }
} 

var xhr_again = false; //deffered check timeout id

function check_update()
{ 
  if(xhr_again) return;
  if(xhr.readyState!=0 && xhr.readyState!=4) 
    { xhr_again = setTimeout(function(){ xhr_again=false; check_update(); }, 1000);	  
	  return; 
    } 
  var sp=new URLSearchParams(load_query);
  sp.set('mode', 'new');
  sp.set('num', last_num);  
  xhr.open('POST', 'events_load.php');
  xhr.send(sp);      
}

function scroll_end()
{ events_area.scrollTo( { top: events_area.scrollHeight, behavior: "instant" } );
  let marked = events_body.querySelectorAll(':scope .marked');
  setTimeout(function(){ marked.forEach( function(n) { n.classList.remove('marked'); } );  }, marked_time);	    
}

function on_events_scroll_bottom_live()
{ if(is_bottom())  btn_last.style.display="none"; }


var update_timer;

function set_update_timer(ms)
{ if(update_timer) clearInterval(update_timer);
  update_timer = setInterval(check_update, ms);
}

var wsocket; 

function create_event_socket()
{
 wsocket = new WebSocket("ws://"+server_module_ip+":"+phmodule_port+"/web/dbevent/d_new_event?"+get_sid());
   
 wsocket.onopen = function(e) {  notify_state.classList.add   ('notifyOK'); 
                                 notify_state.classList.remove('notifyFAIL'); 
								 set_update_timer(30000);
						  	  };
 wsocket.onclose = function(event) {  notify_state.classList.remove('notifyOK'); 
                                      notify_state.classList.add   ('notifyFAIL'); 
									  set_update_timer(5000);
								   };								  									  
								   
 wsocket.onmessage = check_update;								   
}

document.addEventListener("DOMContentLoaded", function()
 { create_event_socket();   
   setInterval(function(){if(wsocket.readyState==3)  create_event_socket();}, 30000);
 })
</script>
<? } //if $live


if($pos == 'last') 
{ ?> 
<script>
document.addEventListener("DOMContentLoaded", function()
{ events_area.scrollTo( { top: events_area.scrollHeight, behavior: "instant" } ); });
</script>
<? }


if($pos == 'center') 
{
?> <script>
document.addEventListener("DOMContentLoaded", function() 
 { 
    var tr=events_body.querySelector(":scope .marked");
	if(!tr) tr=events_body.lastElementChild; 
	if(tr)  tr.scrollIntoView({block: "center", inline: "start"});  
 });
</script> <?
}



if($pos != 'first' ) {?>
<script>
document.addEventListener("DOMContentLoaded", function()  
 { if(events_body.firstElementChild && !events_body.firstElementChild.dataset.eof)
     events_area.addEventListener("scroll", on_events_scroll_top); 
 });
</script> 
<? }

if($pos != 'last') { ?>
<script>
document.addEventListener("DOMContentLoaded", function() 
 { if(events_body.lastElementChild && !events_body.lastElementChild.dataset.eof)
     events_area.addEventListener("scroll", on_events_scroll_bottom); 
 });
</script>
<? }

if($live) { ?>
<script>
document.addEventListener("DOMContentLoaded", function()  {  events_area.addEventListener("scroll", on_events_scroll_bottom_live); });
</script>
<? } ?>


<div id=workarea>

<div id=events_area tabindex="-1">

<table id=events_table class="grid clickable">
<col><col><col class=msg>
<thead><tr><th></th><th></th>
<th class=msg>  <!--[if !mso]>--><div id=nav><? include "events_nav.php"; ?></div><!--<![endif]--></th>
<? foreach($exfields as $f) echo $f; ?>
</tr></thead>

<tbody id=events_body title="     " onclick="body_click(event)">
<?php
include "events_load.php";
switch($pos)
{ case 'first':  events_load('first', $load_params); break; //  //load all

  case 'center': $load_params['count'] = 60;
                 if(!empty($_GET['time'])) // 
                      $load_params['datetime'] = (empty($_GET['date']) ?  date('Y-m-d') : $_GET['date']).' '.$_GET['time'];
                 else
                 if(!empty($_GET['num'])) // 
                      $load_params['num'] =  $_GET['num'];
  
                 events_load('prev', $load_params);         // 
                 events_load('from', $load_params); break;

  case 'last'  : $load_params['count'] = 100;
                 events_load('last', $load_params);	break; // 
}
?> 
</tbody>
</table>
 


<div id='last'></div> <!-- # to last anchor -->

</div> <!-- events_area -->

<div id=data_area>
<!--
<form action='z.php?fff' method=post>
<input name=val value=3 placeholder=test>
<input type=submit>
</form> -->
<?
//   $dt = new DateTime('today');
   
  //$dt =  DateTime::createFromFormat('G:i', '21:00');

  //$dt->modify('2020-01-01');
  //var_dump(localtime());
  //echo $_SERVER['REQUEST_TIME'];
//  echo $dt->format('d.m.Y G:i:s'); 
  
//   var_dump($_GET);
?>
</div> <!-- data_area -->

</div>  <!-- workarea -->
</body>
</html>
