<?php
ob_start();

function fail($msg, $code=400)
{
 ob_clean();
 http_response_code($code);
 header('Content-Type: text/plain');
 die($msg);
}

function debug_break($v)
{ fail(var_export($v, true));}


//       
$fail_error_map=[];

function fail_exception_handler($e)
{ global $fail_error_map;
  $msg=$e->getMessage();
  foreach($fail_error_map as $key=>$s)
   if(str_contains($msg,$key))
     fail($s);	         
  fail($msg);  //.' '.$e->getTraceAsString()
}

function fail_error_handler($errno, $errstr, $errfile, $errline)
{ fail(basename($errfile)." [line $errline]: $errstr", 500); }

set_error_handler("fail_error_handler");
set_exception_handler('fail_exception_handler');
