<?php
include_once("login.php"); 
include_once("colors.php"); 

if($_SERVER['REQUEST_METHOD']==='POST')
  draw_userlist($_GET['type'] ?? $_POST['type'], $_POST);
else {?>

<script>
function find_userlist_option(list, name) //return option or null
{ for(let op of list.options)
    if(op.value==name)
      return op;	 
  return null;	  
}

function find_userlist(list, name) //return usernum OR '' 
{ 
  if(op=find_userlist_option(list, name))
        return op.dataset.num;	 
  else	return '';   
}
</script>
<? }  



function draw_userlist($type, $params=[])
{
global $db;
switch($type)
{
 case 'owner':  $q=$db->prepare_execute(
                              "select o.user_ref, u.username, o.color from D_OWNERS o
                               join USERS u on u.num=o.user_ref
							   join DW_USER_STATES s on u.num=s.user_ref and s.workflow=0
							   where s.state=0".(empty($params['group']) ? '' : " and u.usergroup=:group" )
							   .sql_where(" and u.usergroup",RT_GROUPS).' order by u.username', $params); 
	             break;							 
				 
 case 'deleted': $q=$db->prepare_execute
                             ("select u.num, u.username from USERS u 
                               left join D_OWNERS o on u.num=o.user_ref
							   join DW_USER_STATES s on u.num=s.user_ref and s.workflow=0
							   where o.user_ref is null and s.state=0".(empty($params['group']) ? '' : " and u.usergroup=:group")
							   .sql_where(" and u.usergroup",RT_GROUPS).' order by u.username', $params); 
	             break;							 
 
 case 'guest': $q=$db->prepare_execute
                            ("select u.num, u.username, o.color, d.data_value as org from USERS u
							  join DW_USER_STATES s on u.num=s.user_ref and s.workflow=0
							  left join D_OWNERS o on u.num=o.user_ref
 					          left join D_GUEST_DATA d on d.guest=u.num and d.data_type=1
							  where s.state=1".(empty($params['group']) ? '' : " and u.usergroup=:group")
							  .sql_where(" and u.usergroup",RT_GROUPS).' order by u.username', $params); 
               break;							   
 
 case 'history': $q=$db->query('select id,text_value from HISTORY where id_type=3 order by 2,1'); break;
 
 
 case 'groupname': echo $db->prepare_execute('select g.groupname from USERS u
                                              left join GROUPS g on u.usergroup=g.num 
                            				  where u.num=:user', $params)->fetchColumn();
                   return;
				   
 case 'orgname':  echo $db->prepare_execute('select data_value from D_GUEST_DATA where guest=:guest and data_type=1', $params)->fetchColumn();            
				  return;	
				  
 case 'orglist': foreach($db->query("select distinct data_value from D_GUEST_DATA where data_type=1 and data_value!='' and data_value is not null order by 1") as [$org])
                  echo "<option>$org</option>"; 
				 return; 

 
/* 
 case 'user':    $q=$db->query('select u.num, u.username, o.color from USERS u 
    							left join D_OWNERS o on u.num=o.user_ref
								where u.num='.intval($_POST['num'])); 
                 $q=$q->fetchAll();
				 if(!$q) $q=$db->query('select id,text_value from HISTORY where id_type=3 and id='.intval($_POST['num'])); 
                 break;*/

 default: fail("Unknown type: $type");
} 

$dup_count=0;
$prev_name=null;
foreach($q as $row) //[$num, $name, $color]
{
 echo "<option data-num=$row[0]";
 if(isset($row['COLOR'])) echo ' data-color="',html_color($row['COLOR']),'"';
 if($row[1]==$prev_name)
      $dup_count++;
 else $dup_count=0; 
 $name=htmlspecialchars($row[1]);
 if($dup_count) $name.=" ($dup_count)";
 echo " value=\"$name\">\r\n";
 $prev_name=$row[1]; 
} 

} //draw_userlist

