<?
function draw_name_value($name, $value)		  
{ echo "name=\"$name\" value=\"",htmlspecialchars($value ?? ''),'"'; }

function draw_value($name)		  
{ draw_name_value($name, $GLOBALS[$name] ?? null); } 

function draw_date_value($name)		  
{ global $$name;
  echo 'type=date ';
  draw_name_value($name, ($$name ?? null) ?  (new DateTime($$name))->format('Y-m-d') : '');
} 

function draw_datetime_value($name)		  
{ global $$name;
  echo 'type="datetime-local" ';
  draw_name_value($name, ($$name ?? null) ?  (new DateTime($$name))->format('Y-m-d\TH:i:s') : '');
} 

 
function draw_radios($name, $items)		  
{ global $$name;  
  foreach($items as $key=>$value)
   echo "<label><input type=radio required name=$name value='$key'", ($$name ?? null)==$key ? ' checked' : '',">$value</label>\r\n";  
}

function draw_radio($name, $value)		  
{ global $$name;
  echo "<input type=radio name=$name value=$value";
  if(($$name ?? null)==$value) echo ' checked';
  echo ">\r\n";
}

function draw_check($name, $unchecked=0, $checked=1)		  
{ global $$name;
  echo "<input type=hidden name=$name value=$unchecked>";
  echo "<input type=checkbox name=$name value=$checked";
  if(($$name ?? null)==$checked) echo ' checked';
  echo ">\r\n";
}

function draw_flag($name)
{ global $$name;
  echo "<input type=checkbox name=$name";
  if($$name ?? null) echo ' checked';
  echo ">\r\n";
}		  

function draw_select($name, $items, $attr='')		   
{global $$name;
 echo "<select name=\"$name\" $attr>\r\n";
 foreach($items as $key=>$value)
    echo "<option value='$key'", ($$name ?? null)===$key ? ' selected' : '' ,">",htmlspecialchars($value ?? ''),"</option>\r\n"; 
 echo "</select>";
}	 

function draw_lookup($name, $pairs, $attr='')		  
{
 $items=array_combine(array_column($pairs, 0), array_column($pairs, 1));
 draw_select($name, $items, $attr);
}	 
 
function draw_memo($name, $attr='')		   
{ global $$name;
  echo "<textarea name=\"$name\" $attr>", htmlspecialchars($$name ?? ''), "</textarea>\r\n";
}
 
function draw_option($opts, $key)
{ echo "name='$opts","[$key]' value='", $GLOBALS[$opts][$key]->get() ,"'"; }
 

function draw_check_option($opts, $key, $checked=1)
{ echo "<input type=checkbox name='$opts","[$key]' value='$checked'", $GLOBALS[$opts][$key]->get()==$checked ? ' checked' : '',">"; 
}

function get_form_file($name, &$result) // bool:    
{
 $info=$_FILES[$name] ?? false;
 if(!$info) return false;
 
 if($info['name'])
     if($info['tmp_name'])  $result = file_get_contents($info['tmp_name']); 
                      else  throw new Exception("   $info[name]");		 
 else $result=null;
 return true;
}


 