<?php
include_once "elacset.php"; 
include_once "WF7.php"; 

assert_right(RT_FUNCTIONS, RI_LEAVES);
assert_right(RT_FUNCTIONS, RI_SYSTEM);


new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name = 'LEAVE_TYPE'; 
      public $visible = false;
 	  public $data= true;
	  public $generator='D_GEN_LEAVE_TYPES';
    },
    new class extends StringField
    { public $name = 'CODE';
      public $caption = '';  	
	  public $size = 3;	    
    },	
    new class extends StringField
    { public $name = 'NAME';
      public $caption = '';  	  
	  public $size = 64;
    },
    new class extends StringField
    { public $name = 'FLAGS';
      public $caption = '';  	  
	  public $size = 64;
	  public $required=false;
    }
  ];   


  $this->select_sql  = 'select * from D_LEAVE_TYPES order by code';
  $this->refresh_sql = 'select * from D_LEAVE_TYPES where leave_type = :leave_type'; 
  $this->delete_sql = 'delete from D_LEAVE_TYPES where leave_type = :leave_type';

  $this->update_sql = 'update D_LEAVE_TYPES set 
                         code = :code,  name = :name, flags = :flags
                         where  leave_type = :leave_type';

  $this->insert_sql = 'insert into D_LEAVE_TYPES (leave_type, code, name, flags)
                       values( :leave_type, :code, :name, :flags)';
  
 }

 

 }; //TDataset 