<?php 
include_once('login.php');
include_once('formdraw.php');
include_once('TNavDef.php');
include_once('WF7.php');
include_once('colors.php');

assert_right(RT_FUNCTIONS, RI_LEAVES);

if(isset($_GET['id'])) //edit
 extract($db->prepare_execute("select l.*,u.username, g.groupname, e.editor_name, o.color, u.photo_update_time, cast('now' as date) as now
                               from D_LEAVES l 
                               join USERS u on l.user_ref=u.num
							   left join D_OWNERS o on l.user_ref=o.user_ref
							   left join GROUPS g on u.usergroup=g.num
							   left join D_EDITOR_SETTINGS e on e.editor=l.editor
							   where l.id=:id", $_GET)->fetch(PDO::FETCH_ASSOC));
else //new
{
 $ID = false;
 [$START_TIME, $END_TIME] = $db->query('select cast("today" as date), 
                                               cast("tomorrow" as date) from rdb$database')->fetch(PDO::FETCH_NUM);
 
 if(isset($_GET['user'])) 								
   extract($db->prepare_execute('select u.num as user_ref,u.username,u.photo_update_time,o.color 
                                 from USERS u 
								 left join D_OWNERS o on u.num=o.user_ref
								 where u.num=:user', $_GET)->fetch(PDO::FETCH_ASSOC)); 
}
?>

<form id=leaveform class="window screen_center fix-height"  autocomplete=off  spellcheck=false
      on_table_before_post="before_leave_post(event)"
>
	  
<div class=title><? if($ID) echo ' ',$ID; 
                      else  echo ' ';?><div class=winclose title="" onclick="table_close_form(leavel)"></div></div>

<script>

function before_leave_post()
{
  if(!leaveform.USER_REF.value) 
    username.setCustomValidity('  '); 
}
</script>

<style>
#leaveform textarea[name=PRIM] 
    { width: 100%;
      resize: vertical;
    }

#username  { width: 30ch;}		   	 
	 
#leaveform td.TNav { border: none;}	

#leaveform.ts_insert .noinsert  {visibility: hidden;}

#usercolor { min-width:  16em;
             position: relative;
     	     border: 1px solid gray;
			 border-radius: 3px;
           }
		   
#userphoto { max-height: 95%;
             max-width: 95%;
  		   }
		 
#username+button {visibility: hidden;}		   

#leaveform.ts_insert #username:not(:placeholder-shown)+button
                 {visibility: visible;}  
	   
		 
#leaveform input[type='datetime-local']:read-only {background: #DDD;}
		 
</style>



<table>

<tr>
<td class=TNav colspan=2><?  nav_def() ?></td>

<td id=usercolor rowspan=0 <? if(isset($COLOR)) echo color_background_style($COLOR) ?>>
<img id=userphoto class=screen_center <? if(isset($USER_REF)) echo $db->photo_img_src($USER_REF, $PHOTO_UPDATE_TIME)?> alt=''>
</td>

</tr>


<tr class=noinsert><td></td>
<td> <input readonly size=4 <? if($ID) draw_value('ID') ?>">
</td></tr>


<tr><td></td>
<td>
<? if($ID) { ?>
<input readonly value="<? echo $GROUPNAME ?>">
<? } else { ?>
<select id=usergroup onchange='load_userlist()'>
<option value=''></option>
<?php
foreach($db->query('select NUM,GROUPNAME from GROUPS '.sql_where("where num",RT_GROUPS).' order by GROUPNAME') as $row)
 echo "<option value='$row[0]'>$row[1]</option>";
?>
</select>
<? } ?>
</td></tr>

<tr><td></td>
<td style="white-space: nowrap">
<input type=hidden <? draw_value('USER_REF') ?>>
<? 
include_once('filt_users.php');
if($ID) { ?>
<input id=username readonly value="<? echo $USERNAME ?>"><? 
} else { ?>


<datalist id=userlist><? draw_userlist('owner'); ?></datalist>

<script>
function load_userlist()
{ username.value='';
  on_user_change();
  var fd=new FormData;
  fd.set('group', usergroup.value);
  var xhr = new XMLHttpRequest;
  xhr.open('POST', 'filt_users.php?type=owner', false);
  xhr.send(fd);
  if(xhr.status==200)  
       userlist.innerHTML = xhr.responseText;   
  else alert(xhr.responseText); 
}

function on_user_change()
{
 if(username.value)
  if(op=find_userlist_option(userlist, username.value))
   { leaveform.USER_REF.value=op.dataset.num;
     userphoto.src="photo.php?num="+op.dataset.num+'&v='+Math.random();
     usercolor.style.backgroundColor=op.dataset.color ? op.dataset.color : '';
     return;
   }
 userphoto.src='';
 usercolor.style.backgroundColor=''; 
}
</script>

<input type=text id=username required placeholder=' ' list=userlist spellcheck=false onchange="on_user_change()"
       value="<? echo $USERNAME ?? '' ?>"
><? }
 ?><button type=button 
           onclick="username.value=''; 
		            on_user_change()" 
		   title='  ' 
		   style="padding: 1px 3px">x</button> 
</td></tr>

<tr><td></td>
<td>
<? draw_lookup('LEAVE_TYPE',
                array_merge([[null, '']],
                           $db->query('select leave_type,code||"  "||name from D_LEAVE_TYPES '.sql_where("where leave_type",RT_LEAVE_TYPES).' order by code')->fetchAll(PDO::FETCH_NUM)),
	   		   'required'); ?>
</td></tr>


<tr><td></td>
<td><input required <? draw_datetime_value('START_TIME');
                       if($ID && $A_LEVEL && $START_TIME<$NOW) 
					     echo ' readonly'; ?>></td></tr>

<tr><td></td>
<td><input required <? draw_datetime_value('END_TIME');  
                       if($ID && $A_LEVEL && $END_TIME<$NOW) 
					     echo ' readonly'; ?>></td></tr>	   
  


<tr><td></td>
<td>
<?
 draw_lookup('A_LEVEL', 
             array_merge([[null, ' ']],
                         $db->query('select a_level,a_name from D_ACCESS_LEVELS'.sql_where(" where a_level", right_restricted(RT_LEAVE_LEVELS) ? RT_LEAVE_LEVELS : RT_LEVELS).' order by a_name')->fetchAll(PDO::FETCH_NUM))); ?> 
</td></tr>

<tr><td style="vertical-align: top"></td><td><? draw_memo('PRIM', 'rows=4') ?></td></tr>

<tr class=noinsert><td></td>
<td> <input readonly value="<? if($ID) echo (new DateTime($CREATE_TIME))->format('d.m.Y G:i'); ?>">
</td></tr>

<tr class=noinsert><td></td>
<td> <input readonly value="<? if($ID) echo $EDITOR_NAME ?>">
</td></tr>
</table>

<!-- leaveform -->
</form> 

