<?php
include_once("login.php"); 
include_once("TNavDef.php"); 
include_once("colors.php"); 
include_once("formdraw.php"); 

$a_level=intval($_REQUEST['a_level']);

assert_right(RT_FUNCTIONS, RI_ACCESSLEVELS);
assert_right(RT_LEVELS, $a_level);

if($_SERVER['REQUEST_METHOD']==='POST')
{
  $q=$db->prepare("update D_ACCESS_ZONES set zone=? where reader=? and access_level=$a_level");
  foreach($_POST['r'] as $r=>$z)
  { assert_right(RT_READERS, $r);
    $q->execute([$z, $r]);
  }	
}


?>
<form id=zonesform class=table
      table_data='level_zones.php'
      onchange='update_color(event.target)'
	  onformdata="zonesform_formdata(event.formData)"
	  onreset="setTimeout(update_colors, 0)"
	  >
<input type=hidden <? draw_value('a_level'); ?>>	  
<style>  
#zones th {text-align: left;}
#zones td:first-child + td {padding: 0;}
#zones select { width: 100%;
                height: 100%;
				display: block; 
				border: none;
				background-color: transparent;
    		  }
		  
<?php	
$zones=$db->query("select zone,z_name,color from D_TIMEZONES".sql_where(" where zone",RT_TIMEZONES)." order by zone")->fetchAll(PDO::FETCH_NUM);

foreach($zones as $z)  
  echo "#zones [value='$z[0]']  {background: ",zone_color($z[0], $z[2]).";}\r\n";
?>			  
</style>	

<script>
function zonesform_formdata(fd)
{ //remove unchanged fields 
  for(let o of zones.querySelectorAll(':scope option:checked'))
    if(o.defaultSelected)
       fd.delete(o.closest('select').name);
}

function update_color(n)
{  n.parentElement.setAttribute('value', n.value); }

function update_colors()
{ for(let n of zones.querySelectorAll(':scope select'))
    update_color(n);
}

table_dbform_init(zonesform);
update_colors();
</script>


<table id=zones class=grid>
<caption class=TNav><?  nav_form_def();  ?></caption>
<colgroup>
 <col style="width: auto;">
 <col style="width: 50%;">
</colgroup>
<tr><th></th><th> </th></tr>

<?php

foreach($db->query("select az.reader, ar.read_name, az.zone
                   from D_ACCESS_ZONES az, D_ABSTRACT_READERS ar
                   where az.access_level=$a_level and az.reader=ar.reader ".
				   sql_where(" and az.reader",RT_READERS)." order by ar.read_name") as $r)
{
 $sn = "r[$r[READER]]";
 $$sn = $r['ZONE'];

 echo "<tr>", "<td>$r[READ_NAME]</td>";
 echo "<td>"; draw_lookup($sn, $zones);  echo "</td></tr>", "\r\n"; 
} 
?>			  
</table>
</form> 
 