<?php
include_once "system.php";
include "rights.php";
include "right_def.php";

$editor = null;
$editor_sid = $_COOKIE['sid'] ?? null; // id 
$editor_data = null; //   

if($editor_sid)
{
 $q=$db->prepare('select s.editor, e.editor_name, s.ip, s.last_alive, e.notify_ckeck_realtime, e.notify_check_onrun, e.notify_check_onexit, e.notify_play_sound, e.notify_check_phmodules, cast("now" as date) as now
                  from D_WEB_SESSION s, D_EDITOR_SETTINGS e where e.editor=s.editor and s.sid=?');
 $q->execute([$editor_sid]);
 if($editor_data=$q->fetchObject())
  if($editor_data->IP==$_SERVER['REMOTE_ADDR'])
  {
   $editor = $editor_data->EDITOR;
   
   $now = new DateTime($editor_data->NOW); 
   $dt = new DateTime($editor_data->LAST_ALIVE); 	
   $dt->add(new DateInterval('PT5M')); //5 min
   if($dt>$now)
   { $q=$db->prepare("update D_WEB_SESSION set last_alive='now' where sid=?");
     $q->execute([$editor_sid]);   
   }	 
  }
}

if(!$editor)
{
  header("Location: logon.php");
  exit;
}

load_rights($db->query("select right_type,right_id from D_WEB_RIGHTS($editor)"));





