<?php 
include "system.php"; 
include "options.php"; 
include "password.php"; 
include "version.php"; 


$error = null;
$user = ''; //default user name to draw

try {

$db_ver = $db->query('select db_version from d_settings')->fetchColumn();

if($db_ver!=DB_VERSION)
  throw new Exception("  : $db_ver. : ".DB_VERSION);

if($_SERVER['REQUEST_METHOD']==='POST')
{  
  $ip=ip2long($_SERVER['REMOTE_ADDR']);  
  $user=$_POST['user'];
  
  $q=$db->prepare("select editor, actived, hash2,editor_name from D_EDITOR_SETTINGS where ".(is_numeric($user) ? 'editor_num' : 'editor_name')."=? order by editor");
  $q->execute([$user]);
  $row=$q->fetchObject();
  if(!$row) {  $pk=$db->query('select gen_id(D_GEN_OPERATORS,1) from rdb$database')->fetchColumn();
			   $q=$db->prepare("insert into history (id,id_type,text_value) values (?,1,?)");
			   $q->execute([$pk,$user]);
               $db->exec("insert into events (event_type,param1,param2) values (103, $pk, $ip)");
               throw new Exception('    '); 
            } 			   
  $editor= $row->EDITOR;
  $user  = $row->EDITOR_NAME;
  if(!$row->ACTIVED) { $db->exec("insert into events (event_type,param1,param2) values (104, $editor, $ip)");
                       throw new Exception('     '); }
					
  if(!isset($_POST['ok'])) //do help
  {  
     header("Location: waithelp.php?start&editor=$editor");
     exit; 
  }
					  
  if($row->HASH2 != HashPassword2($_POST['password'])) 
                     { $db->exec("insert into events (event_type,param1,param2) values (102, $editor, $ip)");
					   throw new Exception(' '); 
					 }
  $db->exec("execute PROCEDURE D_CLEAN_SESSIONS"); //cooperative garbage collection

  //generate sid
  $alph = implode(range('0','9')).implode(range('a','z')).implode(range('A','Z'));
  $sid='';
  for($i=0; $i<16; $i++)  $sid.=$alph[random_int(0, strlen($alph)-1)];
 
  $q=$db->prepare("insert into D_WEB_SESSION (sid, editor, ip) values (?,?,?)"); 
  $q->execute([$sid, $editor, $_SERVER['REMOTE_ADDR']]);
  
  $db->exec("insert into events (event_type,param1,param2) values (100, $editor, $ip)");

  setcookie('editor', $editor, strtotime('+30 days'), '/logon.php');  
  setcookie('sid',  $sid); 
  header("Location: index.php?login");
  exit; 
}
else //GET
  if(isset($_COOKIE['editor']) || ($config_ini['DemoMode'] ?? 0))
    $user = $db->query('select editor_name from D_EDITOR_SETTINGS where editor='.intval($_COOKIE['editor'] ?? 1))->fetchColumn(); 
  

} catch (Exception $e) { $error = $e->getMessage(); }  


?>
<!DOCTYPE html>
<html>
<head>
<link rel=stylesheet href="window.css">
<link rel=stylesheet href="common.css">
<link rel=stylesheet href="TButton.css">

<? include "vendor.php"; 
   include "lang_ind.php"; ?>

<link rel="icon" href="<? echo VENDOR_ICON ?>">   
   
<style>

 html {  height: 100%; }

 #client {position: relative;}
 
 #url { bottom: 5px;
		left:  32px;
		width:  145px;
		height: 25px;
		position: absolute;
      }

 
/*
 #client> :first-child ~ *  { position: absolute; } 
		 
	
 :root { --client-width: 400px;
         --align-left:   225px; 
         --align-right:  25px; 
         --align-width:  calc(var(--client-width) - var(--align-left) - var(--align-right));
       }		
	   
 .label { left: 180px; 
          font-size: smaller;
        }		   	   
	   
 .password { top: 103px;  }
 .user     { top: 51px;   }
 
 #lang  { left: calc(var(--align-left) + var(--align-width) + 3px);  
          top: 103px; 
        }
 
 .help { top: 140px; 
         text-align: center;		 
	   }  
	  
 .help button { background: none; 
                border: none;	
     	     	font-size: small;
				color: blue;
				white-space: nowrap;
				cursor: pointer;
			  }
 
 .help a, .help a:visited  
       { color: blue; 
         text-decoration: none;
       }
 
 .TButton { width: 70px;
        	top: 193px;  }	  
   

 input {  left:  var(--align-left);
          width: var(--align-width);	}
	
  .leftline  {left:  var(--align-left); }	
  .rightline {right: var(--align-right);}	 */
	
	
 .TButton { width: 70px; }	
		   
 #version {left: 3px; top: 0;
           font-size: smaller;
		   position: absolute;   }		   
		   
 #err { top: 15px; 
        width: 100%;
		text-align: center;
		color: red;
	    font-size: larger;
      }		
	  
	  
table { border-spacing: 0; 
        right: 25px;
        top: 51px; 
		position: absolute; }	  
		
table input { width: 100%;}		 

td {padding: 0; }

td:nth-child(1) {font-size: smaller;
                 padding-right: 2px;
                }
				
td:nth-child(2) {width: 150px}
	
tr:nth-child(2) {height: 31px;}   

tr:nth-child(3)>td:nth-child(2) {position: relative;}

#lang           {position: absolute;
                 left: 100%;
				 top: 0;
				 padding-left: 2px;
				}


tr:nth-child(4) {height: 34px;
                 text-align: center;
				 vertical-align: bottom;}
				 
tr:nth-child(5) {height: 60px;
				 vertical-align: bottom;}
				

 #help { color: blue;
         cursor: pointer; 
		 font-size: small;
       } 	  
	  
</style>	



<title> </title>

</head>
<body>

<form class='screen_center window' method=post> 
<div class='title'> <? echo PRODUCT_NAME ?>.  </div> 
<div id=client>

<img src='<? echo VENDOR_LOGIN ?>'>
<span id=version><? echo " ".PROGRAM_VERSION.".  ".DB_VERSION."." ?></span>
<div id=err><? echo $error ?></div>

<!-- <span class="label user"></span>
<input class="user"  type=text name=user required autocomplete=off value="<? echo $user ?>"<? if(!$user) echo ' autofocus id=afoc' ?> onkeypress="check_lang(event)">
<span class="label password"></span>
<input class="password" type=password name=password<? if($user) echo ' autofocus id=afoc' ?> onkeypress="check_lang(event)">
<span id=lang><span></span></span>
<button type=submit class="TButton leftline"> <img src="img/ok.png"><span>OK</span></button>
<button type=reset  class="TButton rightline" onclick="afoc.focus()">
                                              <img src="img/cancel.png"><span></span></button>
<div class="help leftline rightline">
<button type=submit name=help> ?</button>
</div>		
 -->
<a href="<? echo VENDOR_URL ?>" id=url target="_blank"></a>

<table>
<tr>
<td></td>
<td><input type=text name=user required autocomplete=off value="<? echo $user ?>"<? if(!$user) echo ' autofocus id=afoc' ?> onkeypress="check_lang(event)"></td>
</tr>

<tr><td></td><td></td></tr>

<tr>
<td></td>
<td><input type=password name=password<? if($user) echo ' autofocus id=afoc' ?> onkeypress="check_lang(event)">
    <span id=lang></span>
</td>
</tr>

<tr>
<td></td>
<td><span id=help onclick="this.closest('form').submit();"> ?</span></td>
</tr>

<tr>
<td></td>
<td>
<div style="display: flex; justify-content: space-between;">
<button type=submit name=ok class=TButton> <img src="img/ok.png"><span>OK</span></button>
<button type=reset  class=TButton onclick="afoc.focus()">
                                              <img src="img/cancel.png"><span></span></button>
</div>											  
</td>
</tr>											  
</table>

</div> <!-- client -->
</form>



</body>
</html> 