<?php
include_once('system.php');
include_once('login.php');
include_once('formdraw.php');
include_once('TNavDef.php');
include_once('colors.php');


$oper = intval($_REQUEST['oper'] ?? $editor); // 
if($oper!=$editor) assert_right(RT_FUNCTIONS, RI_OPERATORS);

if($_SERVER['REQUEST_METHOD']==='POST')
{
$db->autocommit=false;
$db->prepare_execute(
"UPDATE D_EDITOR_SETTINGS SET 
    NOTIFY_CHECK_ONRUN = :NOTIFY_CHECK_ONRUN,
    NOTIFY_CKECK_REALTIME = :NOTIFY_CKECK_REALTIME,
    NOTIFY_PLAY_SOUND = :NOTIFY_PLAY_SOUND,
    NOTIFY_SEND_EMAIL = :NOTIFY_SEND_EMAIL,
    NOTIFY_EMAILS = :NOTIFY_EMAILS,
    NOTIFY_CHECK_ONEXIT=:NOTIFY_CHECK_ONEXIT,
    NOTIFY_CHECK_PHMODULES=:NOTIFY_CHECK_PHMODULES
 WHERE     
            EDITOR = $oper", $_POST);
    
if(isset($_POST['change_sound']) && get_form_file('NOTIFY_SOUND_WAV', $wav))
 $db->prepare("UPDATE D_EDITOR_SETTINGS SET NOTIFY_SOUND_WAV=? 
               WHERE  EDITOR=$oper")->execute([$wav]);

$db->exec("delete from D_NOTIFY_TYPES where editor=$oper");
 
$q=$db->prepare("insert into D_NOTIFY_TYPES (editor, id, restrict_doors)  values ($oper, ?, ?)"); 
$d=$db->prepare("insert into D_NOTIFY_DOORS (editor, id, reader) values($oper, ?, ?)");
foreach($_POST['EV'] ?? [] as $id=>$value)
{ $doors=$_POST['DOORS'][$id] ?? []; 
  $q->execute([$id, $doors ? 1 : 0]);

  foreach($doors as $reader=>$value)
    $d->execute([$id, $reader]);
}
  
			   
$db->exec('execute block as begin post_event "d_init_servmod"; end');			   
$db->autocommit=true;
} //POST


extract($db->query(
"select NOTIFY_CHECK_ONRUN,NOTIFY_CKECK_REALTIME, NOTIFY_CHECK_PHMODULES,
        NOTIFY_PLAY_SOUND,NOTIFY_SEND_EMAIL,NOTIFY_EMAILS,NOTIFY_CHECK_ONEXIT,
		iif(NOTIFY_SOUND_WAV is null, 0,1) as has_sound
 from D_EDITOR_SETTINGS where editor=$oper")->fetch(PDO::FETCH_ASSOC)); 
?>


<form id=notify_cfg class=table
      on_table_after_cancel="notify_cfg_after_cancel()">

<style>
#notify_cfg input[type='checkbox'] { margin-left: 0; }
#notify_cfg>.TNav+div   {padding: 0;}
#notify_cfg>.TNav+div>* {vertical-align: top;}

</style>

<script>
function on_editor_change(ev)
{ ev.stopPropagation();
  var xhr = new XMLHttpRequest();
  xhr.open('GET', 'notify_cfg.php?oper='+ev.target.value, false);
  xhr.send();
  load_form(notify_cfg, xhr);
  table_dbform_init(notify_cfg);
}

function test_mail()
{
  var xhr = new XMLHttpRequest();
  xhr.open('POST', "http://"+server_module_ip+":"+phmodule_port+"/web/warntestmail?editor="+notify_cfg.oper.value+"&"+get_sid(), false);    
  try { xhr.send(); 
        alert(xhr.responseText); 
      } catch(err) {alert("   ");}  
}
</script>

<div class=TNav>
<? $editors=$db->query('select editor,editor_name from D_EDITOR_SETTINGS order by editor_num')->fetchAll();
   if(has_right(RT_FUNCTIONS, RI_OPERATORS) && count($editors)>1) 
   {    echo " ";  draw_lookup('oper', $editors, 'oninput="on_editor_change(event)"');  echo '<br>';  }
   else echo "<input type=hidden name=oper value=$oper>";

 nav_form_def(); ?>
</div>

<div>

<div style="padding: 5px; display: inline-block">
<label><? draw_check('NOTIFY_CHECK_ONRUN') ?>    </label><br>
<label><? draw_check('NOTIFY_CHECK_ONEXIT') ?>    </label><br>
<label><? draw_check('NOTIFY_CKECK_REALTIME') ?>    </label><br>
<label><? draw_check('NOTIFY_CHECK_PHMODULES') ?>  . </label><br>
<label><? draw_check('NOTIFY_PLAY_SOUND') ?>   </label><br>

 <span class=ToolBtn onclick="sndtest.play()" title="  "><img src="img/warn_play.png"></span
><span class=ToolBtn onclick="sndtest.pause()" title=" "><img src="img/warn_stop.png"></span
><label class=ToolBtn title=" wav "><img src="img/warn_open.png">
  <input type=file name=NOTIFY_SOUND_WAV accept=".wav" style="display: none" onchange="change_sound.checked=true">
</label
><? if($HAS_SOUND) { ?><span  class=ToolBtn onclick="change_sound.checked=true;
                              notify_cfg.NOTIFY_SOUND_WAV.value='';
							  table_set_class(notify_cfg, ts_edit);" 
  	   title="  "><img src="img/userclear.png"></span> <? } ?>
<input type=checkbox id=change_sound name=change_sound style="display: none">


<audio id=sndtest src="alarm.php?oper=<? echo $oper ?>" loop></audio> <br> <!-- controls -->

<label><? draw_check('NOTIFY_SEND_EMAIL') ?>  email</label><br>
 email:<br>
<input <? draw_value('NOTIFY_EMAILS') ?> style="width: 100%"><br>

<button type=button class=TButton onclick="test_mail()"><span>  </span></button>
</div>



<style>
#warntypes { display: inline-block; 
             height: 20em;
			 overflow: auto;
			 line-height: normal;
           } 
		   
#warntypes td:nth-child(1) {text-align: center;}		    
#warntypes td:first-child input[type='checkbox'] { margin-left: 0; margin-right: 0;}
#warntypes td:nth-child(2) {text-align: right;}		    
#warntypes td:last-child {padding: 0}
#warntypes th {position: static;}
</style>


<template id=doors>
<?php
foreach($db->query('select READER,READ_NAME from D_ABSTRACT_READERS order by READ_NAME') as $r)
 echo "<label data-reader=$r[0]><input type=checkbox>$r[1]</label>";
?>
</template>



<script>
function door_click(td, event)
{ 
  let div=td.querySelector(':scope>div.doors');
  if(div.classList.contains('expand')) return;
  event.preventDefault();
  
  for(let lab of doors.content.children)
	if(!div.querySelector(':scope [data-reader="'+lab.dataset.reader+'"]'))
	{  lab=div.appendChild(lab.cloneNode(true));
	   lab.querySelector(":scope input[type='checkbox']").name='DOORS['+td.dataset.id+']['+lab.dataset.reader+']';	   
	} 	
  div.classList.add('expand');
  table_set_class(notify_cfg, ts_edit);
}

function notify_cfg_after_cancel()
{  
  for(let div of warntypes.querySelectorAll(':scope .doors.expand'))
   div.classList.remove('expand');

  for(let cb of warntypes.querySelectorAll(':scope .doors input:not(:checked)'))
   cb.parentElement.remove();   
   
}
</script>

<style>
.doors {display: inline-block;}
.doors>label { display: block; }

.doors.expand
 { max-height: 6em;
   overflow: auto;
   background: white;     
 }

.doors:not(.expand) input[type='checkbox'] { display: none; }

.doors:not(.expand) {padding: 2px;}
</style>


<table id=warntypes class=grid>
<th colspan=3>  </th><th></th>
<?
foreach($db->query("select  et.ID,  nt.RESTRICT_DOORS, et.MSG, et.COLOR, et.E_HARDWARE, iif(nt.id is null, '', 'checked') as checked
                    from D_EVENTS_TYPE et 
         			left join D_NOTIFY_TYPES nt on nt.id=et.id and nt.EDITOR=$oper 
                    order by nt.id nulls last, et.ID") as $row)
{
 echo "<tr>
           <td><input name='EV[$row[ID]]' type=checkbox $row[CHECKED]></td>
           <td>$row[ID]</td>
		   <td",color_background_style($row['COLOR']),">$row[MSG]</td>";
 echo "<td",$row['E_HARDWARE'] ? " onclick='door_click(this, event)'" : ''," data-id=$row[ID]>
       <div class=doors>";
 if($row['RESTRICT_DOORS'] && $row['E_HARDWARE'])		   
  foreach( $db->query("select ar.reader, ar.read_name from D_NOTIFY_DOORS nd,D_ABSTRACT_READERS ar
                       where nd.EDITOR=$oper and nd.ID=$row[ID] and ar.reader=nd.reader order by ar.read_name") as $r)
    echo "<label data-reader=$r[0]><input type=checkbox name=DOORS[$row[ID]][$r[0]] checked>$r[1]</label>";

 echo "</div></td></tr>";
}		   
 ?>
</table>







</div>
</form> 