<?php
include_once "system.php";
include_once "login.php";
include_once "right_base.php";
include_once "TNavDef.php";

$oper = intval($_REQUEST['editor']);

assert_right(RT_FUNCTIONS, RI_OPERATORS); 
assert_right(RT_OPERATORS, $oper);

if($_SERVER['REQUEST_METHOD']==='POST')
{ 
 assert_right(RT_RIGHTS, $_POST['right_type']);
 switch($_REQUEST['action'])
 { case 'add': $q=$db->prepare_execute('select * from D_EDITOR_RIGHTS where editor=:editor and right_type=:right_type and right_id=:right_id', $_POST);
               if(!$q->fetch()) 
                  $db->prepare_execute('insert into D_EDITOR_RIGHTS (editor,right_type,right_id) values (:editor,:right_type,:right_id)', $_POST); 
			   break;
   case 'del': $db->prepare_execute('delete from D_EDITOR_RIGHTS where editor=:editor and right_type=:right_type and right_id=:right_id', $_POST); break;
   default: fail('Unknown action'); 
 }
}

?>
<div id=rightsarea>
<style>
		
#rdel {min-height: 10em;}		
			 
#rdel>div {font-weight: bold;
           padding-left: 0.5ch;}			 
#rdel>label>div {padding-left: 2ch;}			 
</style>

<script>
function on_del_right(div)
{ 
     var xhr = new XMLHttpRequest();
     xhr.open('POST', 'oper_rights.php?action=del', false); 
	 var fd=table_row_dataset(div);
     xhr.send(fd);  
     load_form(rightsarea, xhr);
	 
	 if(div=raddarea.querySelector(':scope #radd div[data-editor="'+fd.get('editor')+'"][data-right_type="'+fd.get('right_type')+'"][data-right_id="'+fd.get('right_id')+'"]'))
	 {  div.previousElementSibling.disabled=false;	   	    
	    div.setAttribute('draggable','true');
	 } else console.log('??');
}

function on_show_radd()
{  
  var xhr = new XMLHttpRequest();
  xhr.open('GET', 'oper_radd.php?editor='+oper, false); 
  xhr.send();  
  load_form(raddarea, xhr);
}

function on_add_right(r)
{ r.previousElementSibling.disabled=true;
  var xhr = new XMLHttpRequest();
  xhr.open('POST', 'oper_rights.php?action=add', false);   
  xhr.send(table_row_dataset(r));  
  load_form(rightsarea, xhr);    

}
</script>


<div class=TNav>
<span class='ToolBtn NavBtn' title='  '  onclick='on_show_radd()'><img src='img/navnew.png'></span
><span id=del_right class='ToolBtn NavBtn ToolDisabled' title='  ' 
       onclick="on_del_right(rdel.querySelector(':scope input:checked+div'))"><img src='img/navdel.png'></span>   
<span> </span>	   
</div>

<div id=rdel class=TList onchange="del_right.classList.remove('ToolDisabled')"
        ondragstart="this.drag_item=event.target"
        ondragover="if(oper!=1) event.preventDefault()" 
		ondrop="on_add_right(radd.drag_item);">
<?php
$list=[]; // map rt => [array of ids]
foreach($db->query("select right_type,right_id from D_EDITOR_RIGHTS where editor=$oper order by 1,2") as [$rt, $id])
 $list[$rt][]=$id;

 
foreach($list as $rt=>$ids)
{
 if(isset($get_right_list[$rt])) //rights list 
       $lockup = $get_right_list[$rt]();
 else  $lockup = []; 

 echo "<div>",$right_types[$rt] ?? $rt,"</div>";
 foreach($ids as $id)
  echo "<label><input type=radio name=rdel><div data-editor=$oper data-right_type=$rt data-right_id=$id draggable=true>",$lockup[$id] ?? "id=$id","</div></label>";
}  
?>
</div>
</div>  <!-- rightsarea -->

