<?php
include_once('system.php');
include_once('login.php');
include_once('options.php');
include_once('formdraw.php');
include_once('colors.php');

assert_right(RT_FUNCTIONS, RI_PHOTOID); 

if(isset($_GET['card'])) $num=$db->prepare_execute('select num from D_USER_BY_CARD2(:card, :reader)',$_GET)->fetchColumn();
else
if(isset($_GET['code'])) $num=$db->prepare_execute('select num from D_USER_BY_CODE2(:code, :reader)',$_GET)->fetchColumn();
else fail('invalid query');   
if(!$num) exit('!!!  !!! '.$_SERVER['QUERY_STRING']); 

							
  
extract($db->prepare_execute
                   ("select u.username,g.groupname,d.color, u.photo_update_time, iif(u.photo is null, 0,1) as photo_exist,
                    (select read_name from d_abstract_readers where reader=:reader) as read_name  
                    from D_OWNERS d
                    join USERS u on d.user_ref=u.num
                    left join GROUPS g on u.usergroup=g.num
                    where d.user_ref=$num", $_GET)->fetch(PDO::FETCH_ASSOC));

if(right_restricted(RT_PHOTOID_FIELDS) && has_right(RT_PHOTOID_FIELDS,PHID_NOFIELDS)) {} //no fields
else
{	
echo "<div>";
if(has_right(RT_PHOTOID_FIELDS,RU_NAME))     echo "<input readonly "; draw_value('USERNAME');  echo ">";
if(has_right(RT_PHOTOID_FIELDS,PHID_READER)) echo "<input readonly "; draw_value('READ_NAME'); echo ">";
if(has_right(RT_PHOTOID_FIELDS,RU_GROUP))    echo "<input readonly "; draw_value('GROUPNAME'); echo ">";
 
if(right_restricted(RT_PHOTOID_FIELDS))
     $prop_ids=$editor_rights[RT_PHOTOID_FIELDS];
else $prop_ids=unpack('l*', (new d_option("photo_id/fields"))->get_blob() ?? '');  

if($prop_ids)
 foreach($db->query("select prop_id, prop_value from USER_PROPS where user_num=$num order by prop_id") as [$prop_id, $prop_value])   
  if(in_array($prop_id, $prop_ids))
   echo '<input readonly value="',htmlspecialchars($prop_value),'">';
   
echo "</div>";  
}//else PHID_NOFIELDS




echo "<div name=COLOR", color_background_style($COLOR), ">";
if($PHOTO_EXIST)  echo "<img name=PHOTO ", $db->photo_img_src($num, $PHOTO_UPDATE_TIME)," alt=''>";
echo "</div>"; //COLOR













