<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_SYSTEM);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'DOC_TYPE'; 
      public $caption = '';
 	  public $data= true;
	  public $names= ['update' => 'NEW_DOC_TYPE'];
	  
	  function get_default($action)
	  { return $this->dataset->db->query('select max(doc_type) from D_GUEST_DOC_TYPES')->fetchColumn()+1; }	  
    },
    new class extends StringField
    { public $name = 'NAME';
      public $caption = ' ';  
  	  public $size=64;	  
    }
   ];   


  $this->select_sql = 'select * from D_GUEST_DOC_TYPES  order by doc_type';     
  $this->refresh_sql= 'select * from D_GUEST_DOC_TYPES  where doc_type=:doc_type';
  $this->delete_sql = 'delete from D_GUEST_DOC_TYPES where doc_type = :doc_type';   
  $this->insert_sql = 'insert into D_GUEST_DOC_TYPES (doc_type, name) values (:doc_type, :name)'; 
  $this->update_sql = 'update D_GUEST_DOC_TYPES set  doc_type = :new_doc_type, name = :name where  doc_type = :doc_type'; 
 }
 
 

 
protected $error_map = 
	['PRIMARY or UNIQUE KEY' => '   '];  

 
 
 }; //TDataset 