<?php 
$REPORT=new class 
{ public $id=1;
  public $name=' -13';
  public $description=
"   .
   -13.";
};

if(include "repbase.php") return;
include "options.php"; 

$mnames = [1 => '', '', '', '', '', '', '', '', '', '', '', ''];

$optT13=new d_editor_option('T13');

if($_SERVER['REQUEST_METHOD']==='POST') 
    {$PARAMS=$_POST;
	 $optT13->set_blob(http_build_query($_POST));
	}  
else 
   {parse_str($optT13->get_blob() ?? '', $PARAMS);
    if($config_ini['DemoMode'] ?? 0) 
	{ $PARAMS['month']='2018-03';
      $PARAMS['g']=[39=>1, 40=>1];
	}
   }


$groups=[];
foreach($PARAMS['g'] ?? [] as $key=>$value)
   $groups[]=intval($key);
$tz=intval($PARAMS['tz'] ?? 0);
$month=new DateTimeImmutable($PARAMS['month'] ?? 'midnight first day of this month');


if($_SERVER['REQUEST_METHOD']==='POST') 
{
 include "librep.php";
 if(!$groups) throw new Exception('  ');

 $groups_str=implode(',', $groups);
 $end = $month->modify("first day of next month");
 $day_count=$month->diff($end)->days;

 $title = $mnames[(int)$month->format('n')].' '.$month->format('Y'); 
 

 $users=[]; //, num=>user_object
 $usergroups=[]; // groupid => [users]
 $has_tab=false; //    		 
 $q=$db->query("select u.NUM, u.USERNAME, u.TABEL_NUMBER, u.USERGROUP, g.NUM as GROUPNUM, g.GROUPNAME from USERS u, GROUPS g, d_owners o 
                where u.num=o.user_ref and u.USERGROUP=g.NUM and u.USERGROUP in ($groups_str) order by g.GROUPNAME, u.USERNAME");
 while($u=$q->fetch(PDO::FETCH_OBJ))
 {
   $u->moves=[]; // 
   $u->intervals = array_fill(1, $day_count, []); //  1 
 
   $users[$u->NUM]=$u;
   $usergroups[$u->GROUPNUM][]=$u;
   if($u->TABEL_NUMBER) $has_tab=true;
 } 
 
 if(count($groups)==1 && $users) $title.=', '.$users[array_key_first($users)]->GROUPNAME;    
?>					 
 
<caption><h2> -13  <? echo $title ?></h2></caption>

<colgroup>
<? if($has_tab) echo '<col class=tab>' ?>
<col>
<col class=dates span=<? echo $day_count ?>>
</colgroup>


<thead>
<tr> 
<? if($has_tab) echo '<th class=tab>. </th>' ?>
<th class=name></th>
<?php
for($dt=clone $month; $dt<$end; $dt=$dt->modify('+1 day'))
  echo '<th class=', in_array($dt->format('w'), [0,6]) ? 'hol': 'day','>', $dt->format('j') ,'</th>';  
?>
</tr>
</thead>


<?php
 
// 

$q=$db->prepare(
"select u.num, e.datetime, l.reader_type from events e,d_events_type t,d_ter_zones_link l,users u where
 e.datetime between :start and :end and e.event_type=t.id and
 l.reader=e.param1 and e.system_type=2 and t.e_move=1 and
 u.usergroup in ($groups_str) and
 e.param2=u.num and l.ter_zone+0=:tz order by u.num, e.datetime");

$q->execute(['start' => $month->format('d.m.Y'), 
             'end'   => $end->format('d.m.Y'), 
			 'tz'    => $tz ]);


while($row=$q->fetch(PDO::FETCH_ASSOC)) //   
  if($u=$users[$row['NUM']] ?? null)
   $u->moves[]=$row;
  
foreach($users as $num=>$u)  
  foreach(user_invervals($u->moves) as $in) //   
    $u->intervals[($in[0] ? $in[0] : $in[1])->format('j')][] = $in;



//   
function draw_data($ins) 
{   
  $title='';
  $sum=0; //-   
  foreach($ins as $in)
  {
    if($title) $title.='&#10;';
	$title.= $in[0] ? $in[0]->format('G:i') : '?';
	$title.= '-';
    $title.= $in[1] ? $in[1]->format('G:i') : '?';	
      
    if(!is_null($in[0]) && !is_null($in[1]))
      $sum+=$in[1]->getTimestamp() - $in[0]->getTimestamp();
  }
 	    
  if($sum)    
   {  $text=number_format($sum/60/60, 0, '.', '');
      $title.='&#10;';
	  $title.=': '. date('G:i', $sum);
   }
  elseif($ins) $text='?';
  else         $text='';
  echo "<td class=data title='$title'>$text</td>";  
}
  
 
// 
foreach($usergroups as $gnum=>$gusers)			  
{
 if(count($groups)>1)
   echo '<tr>',"<th class=group colspan=",$has_tab ? 2:1,">",$gusers[0]->GROUPNAME,"</th>", '<td colspan=',$day_count,'></td>',  "</tr>\r\n";
   

 foreach($gusers as $u)			  
 { 
  echo "<tr>";
  if($has_tab) echo "<td class=tab>$u->TABEL_NUMBER</td>";
  echo "<td class=name>$u->USERNAME</td>";
	   
  foreach($u->intervals as $ins)
    draw_data($ins);
 	   
  echo "</tr>\r\n";		  
 }	  
} 
exit(); 
} //POST
//=================================================================================================
//=================================================================================================







//GET
include "form.php"; 
include "excel.php"; 
include "formdraw.php"; 
include "dialog.php"; 
?>

<link rel="icon" href="img/28.png">


<style media=print>   
 #params { display: none; }
</style>	


<style>   
#workarea { padding-bottom: 5px;
            overflow: auto;}


#groups {height: 6.5em;
         overflow-y: auto;
		 background: white;
		 border: 1px solid black; 
	    } 
#groups label:hover		
 { text-decoration: underline;
   color: #0066CC;
 }
		
		
#params { margin: 0 5px 5px 0;  }		

#params button { }

#report:empty {display: none;}	

#tdparams { vertical-align: top; 
            padding: 10px; }				   

</style>	

<style class=rstyle>
#report .dates { width: 4ch; }		

#report th       { white-space: nowrap; 
                   padding: 0 2px;      }

#report th.group  { text-align: left;  }
#report td.tab    { text-align: right;   }
#report td.name   { white-space: nowrap; }

#report td.data   { text-align: center;  }

#report caption>h2 { margin: 5px 0;      }				
</style>

<style media=excel class=rstyle>   
#report td.data  {width: 22px;} 				  						
</style>


<style media=screen>   
 #report .hol  { color: red; }
 #report .day  { color: blue; }
 
 #report th.group  {  border: 1px solid black;
  				      position: unset;
                   } 			   
</style>




<title><? echo $REPORT->name ?></title>

</head>
<body id=workarea>


<form id=params class=window>
<div class=title>  </div>
<table>
<tr>
<td>
<div id=groups>
<label><input type=checkbox name='all' onchange='on_all_change(this)'><span> </span></label><br>
<?php
foreach($db->query("select NUM,GROUPNAME from GROUPS ".sql_where("where NUM",RT_GROUPS)." order by groupname") as [$NUM,$GROUPNAME])
 echo "<label><input type=checkbox value=1 name='g[$NUM]'",  in_array($NUM, $groups) ? ' checked' : '',"><span>$GROUPNAME</span></label><br>\r\n"; 
?>
<script>
function on_all_change(sender)
{
  for(let n of document.querySelectorAll('#groups input'))
    if(n!=sender) 
	  n.checked=sender.checked;  
}
</script>
</div>
</td> <!-- groups -->

<td id=tdparams>
<span class=label></span>
<? draw_lookup('tz', $db->query('select NUM,ZONENAME from TER_ZONES '.sql_where("where NUM",RT_TZ).' order by ZONENAME')->fetchAll(PDO::FETCH_NUM)); ?>
&nbsp;
<span class=label></span>
<input type=month name=month required value='<? echo $month->format('Y-m') ?>'>
&nbsp;
<button type=button id=btnreport class=TButton onclick="on_report()"><img src="img/28.png"><span>C</span></button>

<br><br>
<button type=button id=btnprint  class=TButton onclick="window.print()" hidden><img src="img/38.png"><span></span></button>

<a download='-13'>
<button type=button id=btnexcel class=TButton hidden
        onclick="this.parentNode.href=excel_table(report,'rstyle')"><img src="img/excel.png"><span>Excel</span></button></a>


</td>
</tr>
</table>

<script>
function on_report()
{
 if(!params.reportValidity()) return;   
 btnprint.hidden=btnexcel.hidden=true;
 report.innerHTML='';  
 
 var xhr = new XMLHttpRequest;
 xhr.onreadystatechange = function() 
 { btnreport.disabled=this.readyState<4;
   if(this.readyState==4)
   { dlgwait.close();
     if(this.status==200) 
     { btnprint.hidden=btnexcel.hidden=false;
       report.innerHTML=this.responseText;
     }
     else 
	 if(this.status) dialog_error(this.responseText); 
   }
 }
 xhr.onerror = function()  { dialog_error(" "); }
 
 workarea.appendChild(dlgwait);
 dialog_wait(function() {xhr.abort();},  ' ...'); 
 xhr.open('POST', location.pathname); 
 xhr.send(new FormData(params));
}
</script>
</form>

<table id=report class=grid></table>


</body>
</html>   