<?php
include_once "elacset.php"; 

assert_right(RT_FUNCTIONS, RI_HARDWARE);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends GenIntField
    { public $name = 'NUM'; 
 	  public $data= true;
	  public $visible=false;
      public $generator='GEN_ZONES';
    },
    new class extends StringField
    { public $name = 'ZONENAME';
      public $caption = ' ';  
  	  public $size=64;	  
    }
  ];   
  

  $this->select_sql ='select * from TER_ZONES '.sql_where(' where num',RT_TZ).' order by zonename';   
  $this->refresh_sql='select * from TER_ZONES where num=:num';
  $this->delete_sql ='delete from TER_ZONES where num = :num';
  $this->update_sql ='update TER_ZONES set zonename=:zonename where num = :num';
  $this->insert_sql ='insert into TER_ZONES (num, zonename) values(:num, :zonename)'; 
 }
 
protected $error_map = 
	['FOREIGN KEY' => ' '];  
 
 
 }; //TDataset