<?php 
include "form.php"; 
include "TNav.php"; 
include "table.php"; 
?>
<link rel="icon" href="img/11.png">

<style>
#zonesarea, 
#detailarea 
{ vertical-align: top;
  max-height: 100%;
  display: inline-block;
  overflow: auto;
} 

#zonesarea   { width: 40ch; }
#detailarea  { width: 80ch; }  


#detailarea:not(.zones_ts_selected)
{ display: none;}


#zones col.Z_NAME {width: 100%;}  
#zones th.Z_NAME  {text-align: left;}
#zones td.ZONE    {text-align: right;}



.H_START, .H_END { text-align: right }  
.M_START, .M_END { text-align: left  }  
col.DESCR  { width: 100% } 
th.SUN, th.SAT, th.HOL1 { color: Maroon; }
th.MON, th.TUS, th.WED, th.THE, th.FRI, th.HOL2 { color: blue; }
#ints th {padding-left: 1px; padding-right: 1px;}
#ints td.boolField {padding: 0; }
#ints   { margin-bottom: 2px; } 
</style>

<script>
function on_zone_color(sender)
{ 
  if(tr=table_current_row(zones))
    sender.value=tr.dataset.color ? tr.dataset.color : '#ffffff';
}

function on_color_change(sender)
{ if(tr=table_make_editable(zones))
  { tr.querySelector(':scope input[name="z_name"]').style.backgroundColor=sender.value;
    tr.dataset.color=sender.value;
  }	
}

function on_zone_select(tr)
{ let ro = tr.classList.contains('row-readonly');
  btncolor.classList.toggle("ToolDisabled", ro);
  ints.classList.toggle("readonly", ro);	     
  excepts.classList.toggle("readonly", ro);	     
}
</script>

<title> </title>

</head>
<body id=workarea>

<div id=zonesarea>
<table id=zones class="grid table" 
       table_data="tz_data.php"
       on_table_select  ="on_zone_select(event.detail.row)"
	   table_emit_state="#detailarea"
	   >
<caption class=TNav>
<? nav_all();?>
<label id=btncolor class='ToolBtn NavBtn ts_selected ts_edit ts_insert' title='  '>
 <img src='img/color.png'>
 <input type=color style='display: none' onchange='on_color_change(this)'  onclick="on_zone_color(this)" >
</label>

<? nav_label();?>
</caption>
<?php include "tz_data.php";?>
</table>
</div> <!-- zonesarea -->



<div id=detailarea>
<table id=ints class="grid table" 
       table_data="tzi_data.php"
	   table_master=zones   >
<caption class=TNav><? nav_def();?><span class=NavTitle>  </span></caption>
</table>   

<table id=excepts class="grid table" 
       table_data="tze_data.php"
	   table_master=zones           >
<caption class=TNav><? nav_def();?><span class=NavTitle>  </span></caption>
</table>
</div> <!-- detailarea -->

</body>
</html>  