<?php
include_once('login.php');
include_once('formdraw.php');
include_once('colors.php');
include_once('TNavDef.php');
assert_right(RT_FUNCTIONS, RI_USERS);

$action=$_GET['action'] ?? 'show';

$NUM = intval($_GET['num'] ?? 0);

$initial=[]; //initial fields values from user template 



if($NUM)
  extract($db->query("select USERNAME, USERGROUP, TABEL_NUMBER, PRIM, PHOTO_UPDATE_TIME, iif(PHOTO is null, 0,1) as PHOTO_EXIST from USERS where num=$NUM")->fetch(PDO::FETCH_ASSOC));
else
if(isset($_GET['from']))
 $initial+=$db->prepare_execute("select USERGROUP from USERS where num=:from",$_GET)->fetch(PDO::FETCH_ASSOC);

  
if($action=='show')
  extract($db->query("select ACC_LEV,  ACT_DATE,  DAS_DATE,  OWNERACTIVE, COLOR, O_NUMBER, TAB_NUMBER, CARD_CODE from D_OWNERS where user_ref=$NUM")->fetch(PDO::FETCH_ASSOC));

if($action=='new' && isset($_GET['from']))
  $initial+=$db->prepare_execute('select ACC_LEV,  DAS_DATE,  COLOR from D_OWNERS where user_ref=:from',$_GET)->fetch(PDO::FETCH_ASSOC);
  
if($action=='new' && !$NUM && isset($_GET['group']))  
  $initial['USERGROUP']=intval($_GET['group']);
  

if($action=='new') 
  $initial['ACT_DATE']=date('Y-m-d');
 

$initial=array_filter($initial);  
extract($initial);  

//remove time part from date  
if($ACT_DATE ?? null) $ACT_DATE=(new DateTime($ACT_DATE))->format('Y-m-d');
if($DAS_DATE ?? null) $DAS_DATE=(new DateTime($DAS_DATE))->format('Y-m-d');

if(isset($USERGROUP)) assert_right(RT_GROUPS, $USERGROUP);

$groups = array_merge([[null, '']],
          $db->query('select num,groupname from groups '.sql_where("where num",RT_GROUPS).' order by groupname')->fetchAll(PDO::FETCH_NUM));

$levels = $db->query("select A_LEVEL,A_NAME from D_ACCESS_LEVELS"
                     .(right_restricted(RT_LEVELS) ? sql_where(" where A_LEVEL",RT_LEVELS)." or A_LEVEL=$ACC_LEV" : '')
                     ." order by A_NAME")->fetchAll(PDO::FETCH_NUM);

$nulllevels	= array_merge([[null, '']],  $levels);		
				
					 
function draw_value2($name, $enabled=true)		  
{ draw_value($name);
  if(!$enabled) echo ' readonly';
} 					 
		
function draw_lookup2($name, $pairs, $attr, $enabled)		  
{if(!$enabled) $attr.=' disabled';
 draw_lookup($name, $pairs, $attr);
}

function draw_memo2($name, $attr, $enabled)		   
{ if(!$enabled) $attr.=' readonly';
  draw_memo($name, $attr);
}	


function draw_get_card($card_type)		   
{  echo "<span class='ToolBtn cardbtn' onclick='userform_get_card(this.previousElementSibling,$card_type)' title='     '><img src='img/36.png'></span>";
}
?>

<form id=userform class="window screen_center fix-height" autocomplete=off  spellcheck=false  
      onkeydown="if(event.key=='Escape') table_close_form(this)" tabindex="-1"
      oninput="event.target.classList.add('changed')"
	  onreset="table_show_form(this)"
	  onformdata="userform_formdata(event)"
	  >
	  
<script>
function userform_formdata(event)
{ //remove unchanged fields 
  const initial=<? echo json_encode(array_keys($initial)) ?>;
  let fd=event.formData;
  for(let name of [...fd.keys()]) 
    if(!userform[name].classList.contains('changed') && !initial.includes(name))
	   fd.delete(name);
}
</script>	  
	  
	  
<div class=title>  <div class=winclose title="" onclick="table_close_form(userform); table_close_form(userdeffrm)"></div></div>

<div id=userdata>
<div id=usernav  <? if($action=='new' && $NUM) echo "class=restore" ?>>
 <span id=userprev class="ToolBtn NavBtn ts_selected" title=" " onclick="table_prev(users)"><img src="img/userprev.png"></span
><span id=usernext class="ToolBtn NavBtn ts_selected" title=" "  onclick="table_next(users)"><img src="img/usernext.png"></span>

<?php 
if(has_right(RT_USERPROPS,RU_ADD_DELETE)) 
{ nav_new( ['img' => "img/useradd.png",  'onclick' => 'users_new()']);
  nav_del( ['img' => "img/userdel.png" ]);
}  
nav_post(   ['img' => "img/userpost.png"]);
nav_cancel( ['img' => "img/usercancel.png"]);
nav_label(); 

if(has_right(RT_USERPROPS,RU_PRINT))  {
?>

<span id=userpass class="ToolBtn NavBtn ts_selected" title=" " style="float: right" 
      onclick="on_pass()"><img src="img/userpass.png"></span>
   
<script>
function on_pass()
{ 
  var pass=window.open('pass.php', "_blank");
  pass.addEventListener('DOMContentLoaded', on_pass_fill);
}

function on_pass_fill()
{ 
  var doc=this.document;

  let names=userform.USERNAME.value.split(' ');
  for(i=0; i<names.length; i++)   
   for(let n of doc.querySelectorAll('.NAME'+(i+1)))
     n.innerText = names[i];
   
  for(let n of doc.querySelectorAll('.NAME'))
   n.innerText = userform.USERNAME.value;

  for(let n of doc.querySelectorAll('.TAB'))
   n.innerText = userform.TABEL_NUMBER.value;   
      
  for(let n of doc.querySelectorAll('.LEVEL'))
   n.innerText = userform.ACC_LEV.querySelector(':scope option:checked').text;   
      
  for(let n of doc.querySelectorAll('.GROUP'))
   n.innerText = userform.USERGROUP.querySelector(':scope option:checked').text;   
   
  for(let n of doc.querySelectorAll('.PHOTO'))
   n.src = userphoto.src;
   
  for(let n of doc.querySelectorAll('.COLOR'))
   n.style.backgroundColor =  usercolor.style.backgroundColor;
   
  for(let p of userform.querySelectorAll(':scope input[name^=PROP_]'))
   for(let n of doc.querySelectorAll('.PROP'+p.dataset.prop))
     n.innerText=p.value;
   
  doc.title = ' '+(names[0] || '');  
  doc.head.insertAdjacentHTML('afterbegin', '<link rel="icon" href="img/userpass.png">');
  doc.body.insertAdjacentHTML('beforeend',  '<button onclick="window.print()"></button>');
  
}
</script>   
<? } //RU_PRINT ?>
   
</div>

<? if($NUM) { echo "<input class=changed type=hidden "; draw_value2('NUM'); echo '>';}?>
<table id=usertable1>
<tr><td></td>
<td><input required <? draw_value2('USERNAME', has_right(RT_USERPROPS, RU_NAME)); ?>></td></tr>

<tr><td></td
><td><? draw_lookup2('USERGROUP', $groups, '', has_right(RT_USERPROPS, RU_GROUP)) ?></td></tr>

<tr><td></td>
<td><? if(isset($ACC_LEV))
            draw_lookup2('ACC_LEV', $levels, 'required class=userlevel', has_right(RT_LEVELS, $ACC_LEV) && has_right(RT_USERPROPS, RU_LEVEL));
       else	draw_lookup2('ACC_LEV', $nulllevels, 'required class=userlevel', true);
    ?></td></tr>
      
<?php
if($action=='show')
foreach($db->query("select id, a_level from D_OWNER_LEVELS where user_ref=$NUM order by id") as $row)
{
$fn="A_LEVEL[$row[ID]]";
$$fn=$row['A_LEVEL'];
?>
<tr><td title='  '>.</td>
<td><? draw_lookup2($fn, $nulllevels, 'class=userlevel', has_right(RT_LEVELS, $$fn) && has_right(RT_USERPROPS, RU_LEVEL)) ?></td></tr>
<?
}

if(has_right(RT_USERPROPS, RU_LEVEL))
{ 
$A_LEVEL_NEW=null;
?>
<tr><td title='   '>.</td>
<td><? draw_lookup('A_LEVEL_NEW', $nulllevels, 'class=userlevel') ?></td></tr>
<?
} ?>


</table>


<table id=usertable2>
<colgroup><col><col></colgroup>
<tr><td> </td>
<td><input <? draw_value2('TABEL_NUMBER', has_right(RT_USERPROPS, RU_TABNUMBER)); ?>></td></tr>

<? if(has_right(RT_USERPROPS,RU_CARD)) {?>

<tr><td> </td>
<td><input <? draw_value('TAB_NUMBER'); ?>></td></tr>

<tr><td> </td>
<td><input <? draw_value('CARD_CODE'); ?>><? draw_get_card(0); ?></td></tr>  <!-- pattern="[,A-F\d]+" -->

<tr><td> </td>
<td><input <?  if(!($O_NUMBER ?? 0)) $O_NUMBER='';
               draw_value('O_NUMBER'); ?>></td></tr>
<?


foreach($db->query("select t.*, oc.CARD_CODE, oc.O_NUMBER, oc.TAB_NUMBER from d_card_types t
                    left join d_owner_cards oc on oc.user_ref=$NUM and oc.card_type=t.card_type 
					where t.card_type!=0 order by t.card_type") as $row)
{
//   = 0 // = 1   // = 2

if($row['MODE']==0 || $row['MODE']==1)
{ 
  $fn="CARD_CODE_$row[CARD_TYPE]";
  $$fn=$row['CARD_CODE'];  
  echo "<tr><td>",$row['NAME'];
  if($row['MODE']==0 || ($row['MODE']==1 && $row['USE_NUM'])) echo " ";
  echo "</td><td><input "; draw_value($fn);  echo '>';
  draw_get_card($row['CARD_TYPE']);   
  echo "</td></tr>" ;
 
  if($row['USE_NUM']) 
  {
   $fn="TAB_NUMBER_$row[CARD_TYPE]";
   $$fn=$row['TAB_NUMBER'];  
   echo "<tr><td>$row[NAME] </td><td><input ";  draw_value($fn); echo "></td></tr>" ;  
  }  
}

if($row['MODE']==0 || $row['MODE']==2)
{
  $fn="O_NUMBER_$row[CARD_TYPE]";
  $$fn=$row['O_NUMBER'];  
  if(!$$fn) $$fn='';  
  echo "<tr><td>$row[NAME] </td>";
  echo "<td><input "; draw_value($fn);  echo "></td></tr>" ;
}
} //foreach
} //RU_CARD ?>


<tr><td> </td>
<td><input type=date <?  draw_value2('ACT_DATE', has_right(RT_USERPROPS, RU_PERIOD)); ?>></td></tr>


<tr><td> .</td>
<td><input type=date <? draw_value2('DAS_DATE', has_right(RT_USERPROPS, RU_PERIOD)); ?>>
						
<? if($action=='show') { ?>
<span id=useractive data-active=<? echo $OWNERACTIVE ?> title='       ' onclick='alert(this.getAttribute("title"))'></span>
<? } ?>
</td></tr>



<?php  
foreach($db->query("select id, prop_name, prop_value 
                    from USER_PROP_TYPES
                    left join USER_PROPS on prop_id=id and user_num=$NUM
                    order by id") as [$id, $name, $value])
	  
{ $fn="PROP_$id";
  $$fn=$value;
  echo "<tr><td title='$name'>$name</td><td><input data-prop=$id ";
  draw_value2($fn, has_right(RT_USERPROPS, $id));
  echo "></td></tr>" ;
}  
?>

<tr><td colspan=2></td></tr>
<tr><td colspan=2><? draw_memo2('PRIM', 'rows=4', has_right(RT_USERPROPS, RU_PRIM)) ?></td></tr>
</table> <!-- usertable2 -->

</div> <!-- userdata -->

<!-- ======================================================================================== -->
<!-- ======================================================================================== -->








<div id=userinfo>
<span id=pagephoto  class="ToolBtn pagebtn ToolDown" title=" " onmousedown="pagebtn_click(this)"><span></span></span>
<span id=pagerights class="ToolBtn pagebtn" title="  " onmousedown="pagebtn_click(this); userrights_load();"><span></span></span>
<?if($NUM) { ?>
<span id=pageevents class="ToolBtn pagebtn RI_EVENTSBASE" title=" " onmousedown="pagebtn_click(this); userevents_load();"><span></span></span>
<span id=pagedeffer class="ToolBtn pagebtn" title="    " onmousedown="pagebtn_click(this); userdeffer_load();"><span></span></span>
<? } ?>

<script>
function pagebtn_click(btn)
{ 
  for(let b of btn.parentElement.querySelectorAll(':scope>.pagebtn'))
    b.classList.remove('ToolDown');
  btn.classList.add('ToolDown');
}
</script>

<style>
<? gen_RI_style(['RI_EVENTSBASE']) ?>

#userinfo
{ width: 377px;
  border-left: 1px solid white; 
  border-bottom: 2px solid  #ACA899; 
  border-right: 2px solid  #ACA899; 
}

.pagebtn { user-select: none;
           padding: 1px 3px;
		   cursor: pointer;
		   font-size: smaller; 
         }
		 
.userpage {display: none;
           height: 550px;
          }		 

#pagephoto.ToolDown  ~ #usercolor,
#pagerights.ToolDown ~ #userrights,
#pageevents.ToolDown ~ #userevents,
#pagedeffer.ToolDown ~ #userdeffer
         { display: block; }
        		
		 
</style>

<!-- ======================================================================================== -->
<div id=usercolor class=userpage <? echo color_background_style($COLOR ?? null)?>>

<style>
#usercolor { position: relative; }

#userphoto
{ max-height: 95%;
  max-width: 95%;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%,-50%);
}

#colortool
{ position: absolute;
  width: 100%;
  bottom: 0;
}

#colortool>.ToolBtn
{ padding: 2px; 
  vertical-align: bottom;
}
</style>

<img id=userphoto <? if($PHOTO_EXIST ?? false) echo $db->photo_img_src($NUM, $PHOTO_UPDATE_TIME)?> alt=''>



<div id=colortool>

<label class=ToolBtn title="  ,   "
<? if(!has_right(RT_USERPROPS, RU_COLOR)) echo 'style="display: none"'?>>
<img src="img/usercolor.png">
<input type=color style="display: none" <? if(isset($COLOR)) $COLOR=html_color($COLOR);
                                           draw_value2('COLOR');?>
       onchange="usercolor.style.backgroundColor=this.value">
</label>

<?php if(has_right(RT_USERPROPS, RU_PHOTO)) { ?>

<label class=ToolBtn title="   ">
<img src="img/useropen.png">
<input type=file name=PHOTO hidden accept="image/jpeg"  onchange="photo_change(this)">	  
</label>

<script>
function photo_change(inp)
{ var fd = new FormData();
  fd.append("PHOTO", inp.files[0]);
  
  var xhr = new XMLHttpRequest();
  xhr.open("POST", 'photonorm.php?action=preview'); 
  xhr.responseType = 'blob';
  xhr.onload = function()
  { if(this.status==200) 
      userphoto.src=window.URL.createObjectURL(this.response);  
    else
    { alert(this.responseText);
      userphoto.src=window.URL.createObjectURL(inp.files[0]);
    }  
  } 
  xhr.send(fd);
  
  
  if(!userform.USERNAME.value)
  { userform.USERNAME.value=inp.files[0].name.split('.')[0];
    table_form_input_change(userform.USERNAME);
  }
}
</script>


<a class=ToolBtn title="   " 
   onclick="this.href=userphoto.src;
	        this.download=userform.USERNAME.value;">
<img src="img/usersave.png"></a>

<span class=ToolBtn title=" " 
      onclick="userform.PHOTO.value='';
	           table_form_input_change(userform.PHOTO); 
			   userphoto.src=''; ">
	  <img src="img/userclear.png"></span>

<span class=ToolBtn title="  " 
      onclick="photocfg_click()"><img src="img/usersize.png"></span>

<script>
function photocfg_click()
{
 if(photocfg.children.length)
   photocfg.innerHTML='';
 else
 { var xhr = new XMLHttpRequest();
   xhr.open("GET", 'photocfg.php', false); 
   xhr.send();
   load_form(photocfg, xhr);
   table_dbform_init(photocfg);
 } 
}
</script>			   
	  
<? } //RU_PHOTO ?>


</div> <!-- colortool -->
</div> <!-- usercolor -->
<!-- ======================================================================================== -->

<div id=userrights class=userpage>
<table id=tablerights class=grid>
<thead><tr><th></th><th> </th></tr></thead>
<tbody id=bodyrights></tbody>
</table>

<style>
#tablerights {width: 100%}
#tablerights th {width: 50%;
                 position: static;
			    }
#userrights {overflow-y: auto;
             overflow-x: hidden;
            }
</style>



<script>
function userrights_load()
{
  var sp=new URLSearchParams;
									 
  for(let n of userform.querySelectorAll(":scope .userlevel"))
  { n.onchange=on_level_change;
    if(n.value)										 
	 sp.append('level[]', n.value);    
  }										 
										 
  var xhr = new XMLHttpRequest();
  xhr.open("GET", 'userrights.php?'+sp.toString(), false); 
  xhr.send(); 
  if(xhr.status==200)  
         bodyrights.innerHTML = xhr.responseText; 
  else { bodyrights.innerHTML = '';
         alert(xhr.responseText);	 
       } 
}

function on_level_change()
{ if(pagerights.classList.contains('ToolDown'))
   userrights_load();
}
</script>
</div> <!-- userrights -->
<!-- ======================================================================================== -->

<div id=userevents class=userpage>


<script>
function userevents_load()
{
  var fd=new FormData;
  fd.set('mode', 'last');
  fd.set('user', userform.NUM.value);    
  fd.set('start', selevents.value);    
  
  var xhr = new XMLHttpRequest();
  xhr.open("POST", 'events_load.php', false); 
  xhr.send(fd); 
  if(xhr.status==200)  
         bodyevents.innerHTML = xhr.responseText; 
  else { bodyevents.innerHTML = '';
         alert(xhr.responseText);	 
       } 
	   
  userevents.scrollTo( { top: userevents.scrollHeight, behavior: "instant" } );
}
</script>
<style>
#userevents {overflow: auto;  }

#tableevents { width: 100% }		
#tableevents td:first-child {text-align: center;}	 
#bodyevents  { font-size: smaller; }
</style>

<table id=tableevents class=grid>
<caption class=TNav>
<select id=selevents onchange="userevents_load()">
<option value=1> </option>
<option value=7> </option>
<option value=30> </option>
<option value=365> </option>
</select>
<span class=ToolBtn title="" onclick="userevents_load()"><img src='img/upd.png'></span>
</caption>
<tbody id=bodyevents></tbody>
</table>


</div>  <!-- userevents -->
<!-- ======================================================================================== -->

<div id=userdeffer class=userpage>
<style>
#tabledeffer,
#tabledeffer col.ACC_LEV  {width: 100%}

#userdeffer {overflow-y: auto;
             overflow-x: hidden;  }
			
#tabledeffer tr.row-readonly td.DATETIME {background-color: silver}			

#tabledeffer.readonly caption {display: none;}


#userform.ts_insert #btnadddef {display: none;}

</style>

<script>
function userdeffer_load()
{ table_init(tabledeffer);
  tabledeffer.table_params['USER_REF']=userform.NUM.value;
  table_reopen(tabledeffer)
}

function userdeffer_show(tr)
{ 
   if(tr.classList.contains('row-readonly'))
        table_close_form(tabledeffer);
   else table_show_form(tabledeffer);
}
</script>


<table id=tabledeffer class="table grid noinplace"
       table_data="userdef.php"
	   table_form=userdeffrm

  	   on_table_select="if(!userdeffrm.hidden)  userdeffer_show(event.detail.row)"
	   on_table_dblselect="userdeffer_show(event.detail.row)" 
	   on_table_after_post="table_close_form(this)"
	   >
</table>

<? if(has_right(RT_USERPROPS, RU_LEVEL)) { ?>	   
<button id=btnadddef type=button class=TButton onclick='nav_def_insert(tabledeffer)'><img src='img/navnew.png'><span></span></button>
<? } ?>



</div> <!-- userdeffer -->
<!-- ======================================================================================== -->

</div> <!-- userinfo -->

<style>
#userform 
{ background-color: #ECE9D8;
  white-space: nowrap;
  z-index: 100;	
}

#usernav { padding: 3px 1ch 0 2px;
           user-select: none;
         }

#usernav>.ToolBtn {width: 28px;
                   height: 28px;
				   text-align: center; 
				  }
#usernav>* { vertical-align: middle; }				  


#userdata, #userinfo 
         { display: inline-block;
           vertical-align: top;
		 }
		   
		 
#userdata  { width: 44ch; }





#userdata input[name=USERNAME]  { font-weight: bold;}

#userdata>table,
#usertable1 td:nth-child(2),
#usertable1 td:nth-child(2)>*,
#usertable2 *[name^=PROP]
{ width: 100%;}

#usertable2 { table-layout: fixed; }
#usertable2 td:first-child 
{ overflow: hidden;
  text-overflow: ellipsis;
  white-space: nowrap;
}

#usertable2 col:nth-child(1) 
{ width: 14ch }



#userdata textarea[name=PRIM]
{ width: 100%;
  resize: vertical;
}

#useractive { font-size: smaller;  }

#useractive[data-active="1"]::after
{ content: "";
  color: green;
}

#useractive[data-active="0"]::after
{ content: " ";
  color: red;
}

#userdata input[type=date][value=""]:not(:focus):not(.changed)
{ color: transparent; }

.cardbtn
{ vertical-align: middle;
  padding: 1px;
}

#userform.ts_insert .NavLabel::after {content: '';}
#userform.ts_insert .restore .NavLabel::after {content: '';}


</style>	


<style media=print>
 #colortool, #usernav, .cardbtn {display: none;} 
</style>

<script>

function userform_get_card(input, card_type)
{ 
 var xhr = new XMLHttpRequest();
 xhr.open('GET', 'usercard.php?card_type='+card_type, false);
 xhr.send();	
 if(xhr.status==200) 
   if(xhr.responseText)
   { input.value=xhr.responseText;
     table_form_input_change(input);
   }
   else  alert("  .      .");    
 else  alert(": "+xhr.responseText );
}

function userform_on_load()
{if(tr=table_current_row(users))
 { userprev.classList.toggle('ToolDisabled', !tr.previousElementSibling);
   usernext.classList.toggle('ToolDisabled', !tr.nextElementSibling);
 }
}

 
userform_on_load();
</script>


<!--=======================================================================-->
</form> 
