<?php
include_once "elacset.php"; 
include_once "wm_stuff.php"; 

assert_right(RT_FUNCTIONS, RI_WORK_MODES);

new class extends TDataset
{
 
 function init()
 {
  $this->fields=
  [
    new class extends IntField
    { public $name = 'WORK_MODE'; 
      public $caption = '';
 	  public $data= true;
	  public $names= ['update' => 'NEWMODE'];
	  
	  function get_default($action)
	  { return $this->dataset->db->query('select max(work_mode) from D_WORK_MODES')->fetchColumn()+1; }	  
    },
    new class extends StringField
    { public $name = 'NAME';
      public $caption = ' ';  
  	  public $size=64;	  
    },
	
    new class extends WMModeField
	{  public $name  = 'DEF_MODE';  
       public $caption =  ' ';
	}		
  ];
  
  
  $this->select_sql ='select * from D_WORK_MODES order by work_mode';   
  $this->refresh_sql='select * from D_WORK_MODES where work_mode=:work_mode';
  $this->delete_sql ='delete from D_WORK_MODES where  work_mode = :work_mode';
  $this->update_sql ='update D_WORK_MODES set  work_mode = :newmode, name = :name, def_mode=:def_mode
                      where work_mode = :work_mode';
  $this->insert_sql ='insert into D_WORK_MODES (work_mode, name, def_mode) values(:work_mode, :name, :def_mode)';
 }


}; 


  